#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import cgi
import cgitb; cgitb.enable()
import os
import os.path
from M2Crypto import RSA, m2, X509, EVP,Rand, Err
import time
import datetime

class Certificado:
	"Certificado digital X.509"

	# ATRIBUTOS	
	numSer = None	# codigo proporcionado por la CA
	passw = None	# usado para crear la clave privada

	# Subject Name
	cn = None		# common name
	sn = None		# surname
	gn = None		# given name
	serial = None	# código proporcionado por el cliente
	o = None		# organization
	ou = None		# organization unit
	mail = None		# e-mail
	loc = None		# locality
	st = None		# state
	pais = None		# country

	cadCert = None	# longitud de la cadena de certificados si es uno raiz
	numBits = None				# int
	exp = None					# long
	numDiasValidez = None		# int

	dirCA = None				# directorio la CA
	idCA = None					# identificador de la CA
	passwCA = None				# password de la CA para firmar el certificado

#	subjName = {idCA:None, passwCA:None ...}
	rsa = None
	request = None
	cert = None

# METODOS
	def __init__(self, parametros):
		"""Crea un certificado digital a partir de unos parametros que se pasan 
		en la lista de argumentos."""
		rsa = self.generarClaveRSA(self.numBits, self.exp)
		pkey = self.getClaveP(rsa)
		request = self.crearPeticion(pkey)



	def crearEstDir (self):
		""" """
		dirAct = os.getcwd()
		self.dirCA = dirAct + '/CAs/' + parametros[idCA] + '/'
		dirCAPrivate = self.dirCA + 'private/'


	def __init__(self):
		"""Método constructor: Crea un certificado."""
		self.capturarFormularioNC()

		dirAct = os.getcwd()
		self.dirCA = dirAct + '/CAs/' + self.idCA + '/'
		dirCAPrivate = self.dirCA + 'private/'
		
		self.rsa = self.generarClaveRSA(self.numBits, self.exp)
		
		pkey = self.getClaveP(self.rsa)
		self.request = self.crearPeticion(pkey)				# genera la petición

		#	El certificado tiene que ser firmado con la PKey (Se supone que es la publica en la docu. pero debe ser la privada) de la CA.
		pPKey = RSA.load_key(dirCAPrivate + 'cakey.pem', self.web_passphrase_callback_CA)
		check = pPKey.check_key()
		if check == -1:
			print "ERROR: Ha habido un problema en la obtención del par de claves RSA de la CA. No se ha generado el certificado"
		caPkey = self.getClaveP(pPKey)
		self.cert = self.crearCert(self.request, caPkey, self.numDiasValidez) 	# genera el certificado
		self.salvarInfo()


	def salvarInfo(self):
		""" Salva en disco las claves, request (petición) y certificado digital
		"""
		numEnSerial = self.getSerial()
		numSerie = str(int(numEnSerial)-1)
		self.rsa.save_key(self.dirCA + 'private/' + numSerie + 'key.pem', 'aes_256_cbc', self.web_passphrase_callback) #des_ede3_cbc
		# cómo salvar la petición
		self.cert.save_pem(self.dirCA + 'certs/' + numSerie + '.pem')


	def capturarFormularioNC(self):
		"""Mapeo del formulario de entrada."""
		form = cgi.FieldStorage(keep_blank_values=1)	# parsea la petición, form se comporta como un diccionario
		# "keep_blank_values = 1" evita que FielStorage ignore aquellos campos que contengan cadenas vacias			

		# Capturando el contenido del formulario sin errores
		# Campos requeridos:
		self.idCA = form["idCA"].value
		self.passwCA = form["passwCA"].value
		self.cn = form["comName"].value
		self.sn = form["surname"].value
		self.o = form["org"].value
		self.ou = form["uniOrg"].value
		self.mail = form["emaCont"].value
		self.loc = form["ciudad"].value
		self.st = form["provincia"].value
		self.pais = form["pais"].value
		self.passw = form["password"].value
		self.numBits = int(form["numBits"].value)

		dia = int(form["fechaCaduc_1"].value)
		mes = int(form["fechaCaduc_2"].value)
		anyo = int(form["fechaCaduc_3"].value)
		numDiasValidez = self.diasValidez(dia, mes, anyo)
		if form["exp"].value == "RSA_3 (0x03L)":
			exp = m2.RSA_3
		else:
			exp = m2.RSA_F4

		# Campos optativos:
		if form.has_key("givName"):
			gn = form["givName"].value
		else:
			gn = ''
		if form.has_key("serial"):
			serial = form["serial"].value
		else:
			serial = ''
		if form.has_key("numHijos"):
			cadCert = form["numHijos"].value
		else:
			cadCert = ''

		# TODO Capturar los usos del certificado
		

		return {"idCA":idCA, "passwCA":passwCA, "cn":cn, "sn":sn, "o":o, "ou":ou, "mail":mail, "loc":loc, "st":st, "pais":pais, "passw":passw, "numBits":numBits, "numDiasValidez":numDiasValidez, "exp":exp, "gn":gn, "serial":serial, "cadCert":cadCert}

	def diasValidez (self, d, m, a):
		""" Devuelve el número de días que hay entre el día de generación del certificado 
		y la fecha de caducidad elegida en el formulario
		"""
		fechaRev = datetime.date(a, m, d)
		restaObj = fechaRev.__sub__(datetime.date.today())
		dias = restaObj.days
		return dias


	def web_passphrase_callback(self, p="", q=""): # argumentos 'p' y 'q' inútiles pero necesarios pq ya hemos comprobado que passw = vpassw, además  debido a que no se trata de una interface interactiva en tiempo real no se puede seguir la metodología empleada en RSA.py donde def save_key(self, file, cipher='aes_128_cbc', callback=util.passphrase_callback): y util.passphrase_callback requiere entrada de parámetros por consola
		""" Devuelve el password que se obtuvo del formulario.
			El control de diferencias en los passwords se realiza en controlForm().

			Se trata de una función necesaria porque openssl espera un objeto del tipo Python callable.
		"""
		return self.passw

	# XXX Identico a la anterior pero tiene que capturar el password de la CA
	def web_passphrase_callback_CA(self, p="", q=""): # argumentos 'p' y 'q' inútiles pero necesarios pq ya hemos comprobado que passw = vpassw, además  debido a que no se trata de una interface interactiva en tiempo real no se puede seguir la metodología empleada en RSA.py donde def save_key(self, file, cipher='aes_128_cbc', callback=util.passphrase_callback): y util.passphrase_callback requiere entrada de parámetros por consola
		""" Devuelve el password que se obtuvo del formulario.
			El control de diferencias en los passwords se realiza en controlForm().

			Se trata de una función necesaria porque openssl espera un objeto del tipo Python callable.
		"""
		return self.passwCA


	def generarClaveRSA(self, pkb = 1024, e = m2.RSA_F4):
		"""Genera un nuevo par de claves RSA.

		@type pkb: int
		@param pkb: especifica el número de bits en el módulo público, 
		minimo 1024, recomendables 2048.
		@type e: hex long
		@param e: valor a utilizar por el exponente público, 
		recomendable utilizar las constantes openSSL RSA_3 (0x03L) o 
		RSA_F4

		@rtype: M2Crypto.RSA.RSA
		@return: M2Crypto.RSA.RSA object.
		"""
		rsaKeys = RSA.gen_key(pkb, e)
		claveValida = False
		intentos = 0
		while  ((rsaKeys == 0 || claveValida == False) && intentos <= 3):
			print "Error: La clave RSA generada no es correcta. Generando otra..."
			rsaKeys = RSA.gen_key(pkb, e)
			check = rsaKeys.check_key()
			if check == -1:
				print "Error: Ha habido un problema durante la comprobacion de las claves RSA. Generando otras..."
			else if check == 0:
				print "Error: Existe un problema con las claves RSA. Generandolas de nuevo..."
			else:
				claveValida = True
			intentos = intentos+1
		if intentos == 3:
			print "Error Grave: No se ha podido generar la clave RSA.
			return (-1)
		return rsaKeys


	def getClaveP(self, key):
		"""Recibe un par de claves RSA y devuelve la componente pública.

		   @type key: M2Crypto.RSA.RSA
		   @param key: par de claves RSA 

		   @rtype: M2Crypto.EVP.Pkey
		   @return: M2Crypto.EVP.Pkey object.
		"""
		pkey = EVP.PKey()
		pkey.assign_rsa(key)
		return pkey


	def crearPeticion(self, pkey):
		"""Crea una petición de certificado X.509 (X.509 Certificate Request).
	
		   @type pkey: M2Crypto.EVP.Pkey
		   @param pkey: componente pública de par de claves RSA 
		"""

		req = X509.Request()
		req.set_pubkey(pkey)
		name = X509.X509_Name()
		
		# Registro del subject name (para identificar al receptor del certificado)
		name.CN = self.cn
		name.SN = self.sn
		name.GN = self.gn
		name.C = self.pais
		name.ST = self.st
		name.L = self.loc
		name.O = self.o
		name.OU = self.ou
		name.Email = self.mail
		name.serialNumber = self.serial
		
		req.set_subject_name(name)

		# Gestion de extensiones en la solicitud del certificado
		ext1 = X509.new_extension('basicConstraints', 'CA:false')
		extstack = X509.X509_Extension_Stack()
		extstack.push(ext1)
		# Comprobacion del contenido de la pila
		assert(extstack[0].get_name() == 'basicConstraints')
		req.add_extensions(extstack)

		req.sign(pkey, 'sha1')			# Firma de la petición
		return req


	def tratSerial (self):
		""" Acceso de lectura e incremento del contenido del archivo serial.
		"""
		serial = open(self.dirCA + "serial", 'r+w')
		num = int(serial.read())
		numInc = num + 1
		serial.seek(0, 0)
		serial.write(str(numInc))
		serial.close()
		return num


	def getSerial (self):
		""" Devuelve una cadena con el contenido del archivo serial.
		"""
		serial = open(self.dirCA + "serial", 'r')
		num = serial.read()
		serial.close()
		return num


	def crearCert(self, req, caPkey, dias):
		"""Crea el certificado a partir del certifique request, la clave RSA y 
		   el número de días de validez firmado por la CA.
		"""
		pkey = req.get_pubkey()
		if not req.verify(pkey):
			raise ValueError, "Error verificando la clave pública de la petición."
		sub = req.get_subject()

		cert = X509.X509()
		num = self.tratSerial()
		self.numSer = num			# almacenamos el número de serie que le corresponde al objeto self
		cert.set_serial_number(num)
		cert.set_version(2)
		cert.set_subject(sub)
		# Incluyendo el DN de la CA emisora en el certificado
		certCA = X509.load_cert(self.dirCA + 'cacert.pem')
		issuer = certCA.get_subject()
		cert.set_issuer(issuer)

		cert.set_pubkey(pkey)
		notBefore = m2.x509_get_not_before(cert.x509)
		notAfter  = m2.x509_get_not_after(cert.x509)
		m2.x509_gmtime_adj(notBefore, 0)
		m2.x509_gmtime_adj(notAfter, 60*60*24*dias) 	# Período de validez

		# Gestión de extensiones:
		# el tercer argumento a 1 indica que la extensión es crítica
		cert.add_ext(X509.new_extension('basicConstraints', 'CA:false'))
		cert.sign(caPkey, 'sha1')
		return cert





# Las creaciones o actualizaciones de archivos XML no meterlos en la clase Certificado
def actualizaCertsXML(cert):
	""" Actualización del contenido del archivo certs.xml almacenando todos 
		los campos del subject name del certificado pasado como argumento.
	"""
	dirAct = os.getcwd()
	pathXml = dirAct + '/web/CAs/' + cert.idCA + '/certs.xml'
	if not os.access(pathXml, os.F_OK):
		fXml = open (pathXml, 'w')		# el archivo certs.xml ya debería estar creado
		etiquetaRaiz = "<CA id='" + cert.idCA + "'>"
		fXml.write(etiquetaRaiz)
	else:
		fXml = open (pathXml, 'r+w')		# abre el ya existente certs.xml
		fXml.seek(-6, 2)					# desplazamos justo antes de </CA>
	lSNCert = generaLSNCert(cert)			# lista de cadenas con las filas de la estructura XML del certificado
	lSNCert.append("\n</CA>")				# restauramos la etiqueta de cierre del elemento raíz
	fXml.writelines(lSNCert)
	fXml.close()
	

# XXX Podría añadir más campos para permitir más posibilidades de búsqueda
# XXX por ej.: fecha de emisión y caducidad, numBits, exponente (estudiar posibilidades)
def generaLSNCert (cert):
	""" Recibe un certificado digital como argumento y genera una lista de 
		cadenas que conforman una estructura XML válida a partir del Subject 
		Name del certificado
	"""
	lSNCert = []

	raizInicNodo = "\n\t<cert numSer='" + str(cert.numSer) + "'>"
	raizFinNodo = "\n\t</cert>"

	cnNodo = "\n\t\t<cn>" + cert.cn + "</cn>"
	snNodo = "\n\t\t<sn>" + cert.sn + "</sn>"
	gnNodo = "\n\t\t<gn>" + cert.gn + "</gn>"
	paisNodo = "\n\t\t<pais>" + cert.pais + "</pais>"
	stNodo = "\n\t\t<st>" + cert.st + "</st>"
	locNodo = "\n\t\t<loc>" + cert.loc + "</loc>"
	oNodo = "\n\t\t<o>" + cert.o + "</o>"
	ouNodo = "\n\t\t<ou>" + cert.ou + "</ou>"
	emailNodo = "\n\t\t<email>" + cert.mail + "</email>"
	serialNodo = "\n\t\t<serial>" + cert.serial + "</serial>"
	extNodo = "\n\t\t<ext>" + "PENDIENTE DE IMPLEMENTACION (EXTENSIONES)" + "</ext>"
	diasValNodo = "\n\t\t<diasVal>" + str(cert.numDiasValidez) + "</diasVal>"
	
	lSNCert.append(raizInicNodo)
	lSNCert.append(cnNodo)
	lSNCert.append(snNodo)
	lSNCert.append(gnNodo)
	lSNCert.append(paisNodo)
	lSNCert.append(stNodo)
	lSNCert.append(locNodo)
	lSNCert.append(oNodo)
	lSNCert.append(ouNodo)
	lSNCert.append(emailNodo)
	lSNCert.append(serialNodo)
	lSNCert.append(extNodo)
	lSNCert.append(diasValNodo)
	lSNCert.append(raizFinNodo)

	return lSNCert



#	Debemos actualizar /CAs/idCA/gestCerts.html
def actualizaIndex (self):
	""" Actualiza el archivo html añadiendo la información correspondiente a la nueva CA.
	"""
	nuevaInfo = unicode("""
		<li>
		<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
		<tbody>
		<tr>
			<td width="12%" class="imagen"><a href='./CAs/""" + self.idCA + """/""" + self.idCA + """.html'><img src="../web/CAs/candado.png" alt="" title="" border="0" height="60" width="60"></a></td>
			<td width="40%" class="preview"><p><strong>idCA: </strong>""" + self.idCA + """<br />
			  <strong>Nombre: </strong>""" + self.cn + """<br />
			  <strong>Organización: </strong>""" + self.o + """<br />
			  <strong>Fecha de Revocación: </strong>""" + self.frd + '/' + self.frm + '/' + self.fra + """</p></td>
			<td width="48%" class="enlace">
				<a href="./CAs/""" + self.idCA + """/formNC.html" class=""><img src="../web/iconos/script_add.png" width="16" height="16" /> Emitir Nuevo Certificado</a><br/>
				<a href="./CAs/""" + self.idCA + """/revCert.html" class=""><img src="../web/iconos/script_delete.png" width="16" height="16" /> Revocar Certificado</a><br/>
				<a href="./CAs/""" + self.idCA + """/crl.html" class=""><img src="../web/iconos/script_go.png" width="16" height="16" /> Obtener Lista de Revocación de Certificados</a>
		</tr>
		</tbody>
		</table>
		</li>

		<div class="section_break"></div>
	""", 'utf-8')
	dirAct = os.getcwd()
	path = dirAct + '/web/index.html'
	lon = len(path) - 139 # 139 son los bytes que hay desde el final del archivo hasta donde queremos añadir el <li>
	if os.access(path, os.F_OK):
		index = open(path, 'r')
		contenido = index.read()
		index.close()
		pre = contenido[:lon]
		pos = contenido[lon+1:]
		nuevoContenido = pre + nuevaInfo.encode("utf-8") + pos
		index = open(path, 'w')
		index.write(nuevoContenido)
		index.close()
	else:
		print "ERROR: No se encuentra el archivo index.txt en el directorio web/"


#	Crearemos ahora /CAs/idCA/certs/numSerieCert.html
def crearCertHtml (cert):
	# directorio donde guadaremos numSerie.html (numSerie = número de serie del certificado)
	dirAct = os.getcwd()
	pathDir = dirAct + '/web/CAs/' + cert.idCA + '/certs/'
	if not os.access (pathDir, os.F_OK):	
		os.mkdir(pathDir)
	# XXX
	numEnSerial = cert.getSerial()
	numSerie = str(int(numEnSerial)-1)
	# XXX
	f = open(pathDir + numSerie + '.html', 'w') # creamos el archivo

	# dando formato html al certificado
	certificado = cert.cert.as_text()

	contenido = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Zona de Control del Certificado """ + numSerie + """</title>
	<link rel="stylesheet" type="text/css" href="../../../estiloInd.css" media="all">
	<script type="text/javascript" src="../../../view.js"></script>
	<style type="text/css">
		lis {clear:both; display:table;}
		span {float:left; padding: 0 46px 0 45px;}
	</style>
	<script type="text/javascript">
	<!--
	function seleccion(opc)
	{
		//escondemos todos los contenidos
		document.getElementById("op1").style.display="none";
		document.getElementById("op2").style.display="none";
		switch(opc)
		{
			case 1:
				//mostramos el contenido de la primera opción
				document.getElementById("op1").style.display="block";
				break;
			case 2:
				//mostramos el contenido de la segunda opción
				document.getElementById("op2").style.display="block";
				break;
		}
	}
	//-->
	</script>
</head>
<body id="main_body" >
	<img id="top" src="../../../forms/top.png" alt="">
	<img src="../../../miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../../../index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Zona de Control del Certificado """ + numSerie + """</h2>
			<p>Desde esta página puede observar los valores seleccionados para crear el certificado y el propio certificado en formato texto.</p>
		</div>
		<ul>
		<br/>
		<lis>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(1);'><img src="../../../iconos/magnifier_zoom_in.png" width="16" height="16" /> Ver Configuración</a></span>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(2);'><img src="../../../iconos/script.png" width="16" height="16" /> Ver Certificado</a></span>
			<span><a href='javascript:seleccion(3);'><img src="../../../iconos/magifier_zoom_out.png" width="16" height="16" /> Ocultar</a></span>
		</lis>
		<lis id="op1" style="display:block;width:99%;height:100%;"><br/><br/>
			"""# + cf.vistaCA() + 
			"""
		</lis>
		<pre>
		<lis id="op2" style="display:none;width:99%;height:100%;">""" + certificado + """
		</lis>
		</pre>
		<lis id="op3" style="display:none;width:99%;height:100%;">
			Esta opción oculta la tabla
		</lis>
		<div class="section_break"></div>
		<table width="100%" border="0" align="center">
  		<tr>
			<td><div align="center">
				<a href='../../../../CAs/""" + cert.idCA + """/private/""" + numSerie + """key.pem' class=""><img src="../../../iconos/building_key.png" width="16" height="16" /> Descargar Clave Privada</a>
			</div></td>
			<td><div align="center">
				<a href='../../../../CAs/""" + cert.idCA + """/certs/""" + numSerie + """.pem' class=""><img src="../../../iconos/building_edit.png" width="16" height="16" /> Descargar Certificado</a>
			</div></td>
  		</tr>
</table>
		<div class="section_break"></div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../../../forms/bottom.png" alt="">
</body>
</html>""", 'utf-8')
	f.write(contenido.encode("utf-8"))
	f.close()


def vistaCA(self):
	# SIMILAR A LA VISTA PREVIA
	pre = """<li id="li_1" >
		<label class="description" for="idCA">Nombre Identificador de la CA: </label>
		<div>
			""" + self.idCA + """
		</div>
	</li>
	<li class="section_break">
		<h3>Informacion para incluir en el Certificado Raiz de la CA:</h3>
		<p>Rellene los siguientes campos que permiten identificar a la persona, empresa u organizacion responsable de la CA.</p>
	</li>"""

	cnCode = """
	<li id="li_3" >
		<label class="description" for="nombreCom">Nombre Comun (CN): </label>
		<div>
			""" + self.cn + """
		</div>
	</li>"""
	snCode = """
	<li id="li_4" >
		<label class="description" for="apellido">Apellido (SN): </label>
		<div>
			""" + self.sn + """
		</div>
	</li>"""

	gnCode = """
	<li id="li_5" >
		<label class="description" for="sobrenombre">Sobrenombre (GN): </label>
		<div>
			""" + self.gn + """
		</div>
	</li>"""

	nsCode = """
	<li id="li_9" >
		<label class="description" for="serial">Numero de Serie: </label>
		<div>
			""" + self.serial + """
		</div>
	</li>"""

	oCode = """
	<li id="li_6" >
		<label class="description" for="organizacion">Organizacion (O): </label>
		<div>
			""" + self.o + """
		</div>
	</li>"""

	ouCode = """
	<li id="li_7" >
		<label class="description" for="unidadOrg">Unidad Organizativa (OU): </label>
		<div>
			""" + self.ou + """
		</div>
	</li>"""

	emailCode = """
	<li id="li_10" >
		<label class="description" for="email">Email: </label>
		<div>
			""" + self.mail + """
		</div>
	</li>"""

	dirCode = """
	<li id="li_8" >
		<label class="description" for="direccion">Datos de Localizacion: </label>
	</li>"""

	locCode = """
	<li id="li_10" >
		<label class="description" for="direccion_3">Localidad: </label>
		<div>
			""" + self.loc + """
		</div>
	</li>"""

	estCode = """
	<li id="li_10" >
		<label class="description" for="direccion_4">Estado / Provincia / Region: </label>
		<div>
			""" + self.st + """
		</div>
	</li>"""

	paisCode = """
	<li id="li_10" >
		<label class="description" for="direccion_6">Pais: </label>
		<div>
			""" + self.pais + """
		</div>
	</li>"""

	pos = """
	<li class="section_break">
		<h3>Claves Publica y Privada.</h3>
		<p>Datos necesarios para generar el par de claves RSA asociadas al Certificado Raiz de la CA.</p>
	</li>
	<li id="li_12" >
		<label class="description" for="numBitsPK">Numero de bits de la Clave Privada: </label>
		<div>
			""" + self.nBits + """
		</div>
	</li>
	<li id="li_13" >
		<label class="description" for="exponente">Exponente: </label>
		<div>
			""" + self.exp + """
		</div>
	</li>
	<li id="li_14" >
		<label class="description" for="password">Password: </label>
		<div>
			""" + self.passw + """
		</div>
	</li>
	<li class="section_break">
		<h3>Validez del Certificado.</h3>
		<p>A continuacion indique el periodo de validez del certificado raiz de la CA.</p>
	</li>
	<li id="li_17" >
		<label class="description" for="fechaCaduc">Fecha de Revocacion: </label>
		<div>
			""" + self.frd + '/' + self.frm + '/' + self.fra + """
		</div>
	</li>"""

	vista = pre
	if self.cn != '':
		vista += cnCode
	if self.sn != '':
		vista += snCode
	if self.gn != '':
		vista += gnCode
	if self.serial != '':
		vista += nsCode
	if self.o != '':
		vista += oCode
	if self.ou != '':
		vista += ouCode
	if self.mail != '':
		vista += emailCode
	if self.loc != '' or self.st != '' or self.pais != '':
		vista += dirCode
	if self.loc != '':
		vista += locCode
	if self.st != '':
		vista += estCode
	if self.pais != '':
		vista += paisCode
	vista += pos
	return vista


def generaRespHtml2():
	print ("Se ha generado el certificado")


def generaRespHtml(objCert):
	""" Pagina html que se mostrará tras rellenar el formulario del certificado.
	"""
	# dando formato html al certificado
	certTexto = objCert.cert.as_text()
	numEnSerial = objCert.getSerial()
	numSerie = str(int(numEnSerial)-1)
	html = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Nuevo Certificado Digital emitido con éxito.</title>
	<link rel="stylesheet" type="text/css" href="../web/estiloInd.css" media="all">
	<script type="text/javascript" src="../web/view.js"></script>
</head>
<body id="main_body" >
	<img id="top" src="../web/forms/top.png" alt="">
	<img src="../web/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../web/index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Procesando la peticion... </h2>
			<p>Se están generando el par de claves RSA para el certificado digital, este proceso puede tardar unos segundos. </p>
		</div>
		<ul>
		<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div align="center"><a href="../web/index.html"><img src="../web/iconos/application_home.png" width="16" height="16" />Volver a la pagina de Inicio</a></div></td>
				<td><div align="center"><a href='../web/CAs/""" + objCert.idCA + """/certs/""" + numSerie + """.html'/>Ir a la página de Control del Certificado<img src="../web/iconos/building_link.png" width="16" height="16" /></a></div></td>
				</tr>
			</tbody>
			</table>
		</li>
		<div class="section_break"></div>
		<li>
			<pre>""" + certTexto + """</pre>
		</li>
		<div class="section_break"></div>
		<li>
		<table width="100%" border="0" align="center">
		<tbody>
 		<tr>
    		<td><div align="center"><a href='../../../CAs/""" + objCert.idCA + """/private/""" + numSerie + """key.pem' class=""><img src="../web/iconos/building_key.png" width="16" height="16" /> Descargar Claves RSA</a></div></td>
    		<td><div align="center"><a href='../../../CAs/""" + objCert.idCA + """/certs/""" + numSerie + """.pem' class=""><img src="../web/iconos/building_edit.png" width="16" height="16" /> Descargar Certificado Digital</a></div></td>
 		</tr>
		</tbody>
		</table>
		</li>
		<div class="section_break"></div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../web/forms/bottom.png" alt="">
</body>
</html>""", 'utf-8')
	print html.encode("utf-8")


#	Generamos/actualizamos el contenido de un XML
def actualizaXML (cert):
	""" Genera si no existe o actualiza el contenido de certs.xml
	"""
	# directorio donde se almacena el 
	dirAct = os.getcwd()
	pathXML = dirAct + '/CAs/' + self.idCA + '/'
	f = open(pathDir + 'certs.xml', 'w') 			# crea el archivo si no existía

	xml = """
<ca>
	<certificado>
		<numSerie>093893</numSerie>
		<cn>Huevo de Oro</cn>
		<estado>Valido</estado>
	</certificado>
	<certificado>
		<numSerie>093894</numSerie>
		<cn>Huevo de Cobre</cn>
		<estado>Valido</estado>
	</certificado>
	<certificado>
		<numSerie>093895</numSerie>
		<cn>Huevo de Plata</cn>
		<estado>Revocadp</estado>
	</certificado>
	<certificado>
		<numSerie>093896</numSerie>
		<cn>Huevo de Chocolate</cn>
		<estado>Valido</estado>
	</certificado>
</ca>
"""
	actualizacion = unicode(xml, 'utf-8')

	f.write(actualizacion.encode('utf-8'))
	f.close()



# XXX SCRIPT
	capturarFormularioNC()
	

# XXX




if __name__ == '__main__':
	print "Content-Type: text/html\n"     # sigue HTML	
	certif = Certificado()
	actualizaCertsXML(certif)
#	print "<br> IMPRESIÓN DEL CERTIFICADO as_text: <br>"
#	print '<pre>' + certif.cert.as_text() + '</pre>'
	crearCertHtml (certif)
	generaRespHtml(certif)
