#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import cgi
import cgitb; cgitb.enable()
import os
import os.path
from M2Crypto import RSA, m2, X509, EVP,Rand, Err
import time
import datetime

import _xml
import crl
import lib.miarc_util


# XXX Crear revocados.xml en el directorio raíz de la CA al generarla
def crearRevocadosXML(idCA):
	""" Crea el archivo revocados.xml para la CA cuyo idCA se pasa como argumento, 
	revocados.xml contendrá el número de serie, fecha de revocación y fecha de 
	caducidad de cada uno de los certificado revocados con dicha CA.
	"""

	dirAct = os.getcwd()
	pathXml = dirAct + '/web/CAs/' + idCA + '/revocados.xml'
	if not os.path.exists(pathXml):
		fXml = open (pathXml, 'w')		# crea el archivo revocados.xml
		contenido = """<?xml version="1.0" encoding="UTF-8"?>\n<revocados idCA='""" + idCA + """'>\n</revocados>"""
		fXml.write(contenido)
		fXml.close()
	else:
		print "ERROR: Se ha intentadao crear el archivo: '" + pathXml + "' que ya existe."


# XXX XXX XXX Crear certs.xml con el cert raíz al generar la CA XXX XXX XXX XXX XXX XXX
# Las creaciones o actualizaciones de archivos XML no meterlos en la clase Certificado
def crearCertsXML(idCA):
	""" Crea el archivo certs.xml para la CA cuyo idCA se pasa como argumento, 
	certs.xml contendrá los campos del subject name de los certificado 
	emitidos con dicha CA.
	"""

	# generando la cadena con la fecha actual para el atributo fechaUltRevCad
	fechaActString = lib.miarc_util.fechaActCad()

	dirAct = os.getcwd()
	pathXml = dirAct + '/web/CAs/' + idCA + '/certs.xml'
	if not os.path.exists(pathXml):
		fXml = open (pathXml, 'w')		# crea el archivo certs.xml
		# fechaUltRevCad sirve para identificar el último día que se revisó si había caducado algún certificado
		contenido = """<?xml version="1.0" encoding="UTF-8"?>\n<CA id='""" + idCA + """' fechaUltRevCad = '""" + fechaActString + """'>\n</CA>"""
		fXml.write(contenido)
		fXml.close()
	else:
		print "ERROR: Se ha intentadao crear el archivo: '" + pathXml + "' que ya existe."


class CFormulario:

# XXX XXX XXX MODIFICACION 31 JULIO XXX XXX XXX
# ATRIBUTOS
	numSer = None
	passw = None
	
	# subject name
	cn = None
	sn = None
	gn = None
	serial = None
	o = None
	ou = None
	mail = None
	loc = None
	st = None
	pais = None

	cadCert = None
	numBits = None				# int
	exp = None					# long
	numDiasValidez = None		# int
	fechaCaducidad = None		# string

	dirCA = None				# directorio la CA
	idCA = None					# id de la CA que firma el certificado
	passwCA = None				# password de la CA para firmar el certificado
	tipoCA = True				# Boolean que indica si se trata de un certificado raiz de una CA para miARC
#	subjName = {idCA:None, passwCA:None ...}
	rsa = None
	request = None
	cert = None

	uso = None


# XXX XXX XXX MODIFICACION 31 JULIO XXX XXX XXX


	def __init__(self):
		"""Parsea el formulario de creación de una nueva CA (formNCA.html).

		@return: objeto CFormulario
		"""
		form = cgi.FieldStorage() # parsea la petición, form se comporta como un diccionario
		# Identificador de la CA
		self.idCA = form["idCA"].value

		# Nombre Común (CN)
		if form.has_key("nombreCom") and form["nombreCom"].value != "":
			self.cn = form["nombreCom"].value
		else: # si no se le da un nombre común tomará por defecto el del nombre identificador
			self.cn = self.idCA

		# Apellido (SN)
		if form.has_key("apellido"):
			self.sn = form["apellido"].value
		else: # Hay que ponerlo pq si se deja en blanco no se envía el campo => el if anterior responde False y no estaría declarado self.sn
			self.sn = ''
		
		# Sobrenombre (GN)
		if form.has_key("sobrenombre"):
			self.gn = form["sobrenombre"].value
		else:
			self.gn = ''

		# Número de Serie
		if form.has_key("serial"):
			self.serial = form["serial"].value
		else:
			self.serial = ''

		# Organización (O)
		if form.has_key("organizacion"):
			self.o = form["organizacion"].value
		else:
			self.o = ''

		# Unidad Organizativa (OU)
		if form.has_key("unidadOrg"):
			self.ou = form["unidadOrg"].value
		else:
			self.ou = ''

		# Email
		if form.has_key("email"):
			self.mail = form["email"].value
		else:
			self.mail = ''

		# Localidad
		if form.has_key("direccion_3"):
			self.loc = form["direccion_3"].value
		else:
			self.loc = ''

		# Provincia
		if form.has_key("direccion_4"):
			self.st = form["direccion_4"].value
		else:
			self.st = ''

		# País
		if form.has_key("direccion_6"):
			self.pais = form["direccion_6"].value
		else:
			self.pais = ''

		# Número de Bits de la PrKey
		self.nBits = form["numBitsPK"].value
		
		# Exponente de Key
		self.exp = form["exponente"].value
		
		# Password
		self.passw = form["password"].value

		# Algoritmo de Firma
		self.firma = form["firma"].value
		
		# Fecha de Revocación
		# FR-dia
		self.frd = form["fechaCaduc_1"].value
		if len(self.frd) == 1:
			self.frd = '0' + self.frd
		# FR-mes
		self.frm = form["fechaCaduc_2"].value
		if len(self.frm) == 1:
			self.frm = '0' + self.frm
		#FR-año
		self.fra = form["fechaCaduc_3"].value
# XXX XXX XXX MODIFICACION 31 JULIO XXX XXX XXX
		self.fechaCaducidad = self.frd + '-' + self.frm + '-' + self.fra
# XXX XXX XXX MODIFICACION 31 JULIO XXX XXX XXX

	def web_passphrase_callback(self, p="", q=""): # argumentos 'p' y 'q' inútiles pero necesarios pq ya hemos comprobado que passw = vpassw, además  debido a que no se trata de una interface interactiva en tiempo real no se puede seguir la metodología empleada en RSA.py donde def save_key(self, file, cipher='aes_128_cbc', callback=util.passphrase_callback): y util.passphrase_callback requiere entrada de parámetros por consola
		""" Devuelve el password que se obtuvo del formulario.
			El control de diferencias en los passwords se realiza en controlForm().

			Se trata de una función necesaria porque openssl espera un objeto del tipo Python callable.
		"""
		return self.passw


	def diasValidez (self):
		""" Devuelve el número de días que hay entre el día de generación del certificado 
		y la fecha de caducidad elegida en el formulario
		"""
		fechaRev = datetime.date(int(self.fra), int(self.frm), int(self.frd))
		restaObj = fechaRev.__sub__(datetime.date.today())
		dias = restaObj.days
		return dias


	def crearCAHtml (self):
		# directorio donde guardaremos idCA.html (idCA = identificador de la CA)
		idCA = self.idCA
		dirAct = os.getcwd()
		pathDir = dirAct + '/web/CAs/' + idCA + '/'
		os.mkdir(pathDir)
		# directorio donde guardaremos los html de cada certificado
		pathCertsHTML = pathDir + 'certs/'
		os.mkdir(pathCertsHTML)

		# Copiando el icono candadoAct.png en '/web/CAs/idCA/' puesto que 
		# una CA recien creada está en estado activo.
		pathIconos = dirAct + '/web/images/icons/'
		lib.miarc_util.copiarArchivo(pathIconos + '/candadoAct.png', pathDir + 'candado.png')

		# dando formato texto al certificado
		certificado = cert.as_text()
		# certFormat = certificado.replace('\n', '<br>')

		contenido = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Información General de la CA: """ + self.idCA + """.</title>
	<link rel="stylesheet" type="text/css" href="../../estiloInd.css" media="all">
	<script type="text/javascript" src="../../view.js"></script>
	<style type="text/css">
		lis {clear:both; display:table;}
		span {float:left; padding: 0 46px 0 45px;}
	</style>
	<script type="text/javascript">
	<!--
	function seleccion(opc)
	{
		//escondemos todos los contenidos
		document.getElementById("op1").style.display="none";
		document.getElementById("op2").style.display="none";
		switch(opc)
		{
			case 1:
				//mostramos el contenido de la primera opción
				document.getElementById("op1").style.display="block";
				break;
			case 2:
				//mostramos el contenido de la segunda opción
				document.getElementById("op2").style.display="block";
				break;
		}
	}
	//-->
	</script>
	<script>
		function mostrar(enla) {
		  obj = document.getElementById('oculto');
		  obj.style.visibility = (obj.style.visibility == 'hidden') ? 'visible' : 'hidden';
		  enla.innerHTML = (enla.innerHTML == 'Ocultar Password') ? 'Mostrar Password' : 'Ocultar Password';
		}
	</script>
</head>
<body id="main_body" >
	<img id="top" src="../../images/top.png" alt="">
	<img src="../../images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../../index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Información General de la Autoridad de Certificación """ + self.idCA + """.</h2>
			<p>Esta página le permite comprobar las opciones elegidas durante el proceso de creación de la autoridad de certificación y descargar su certificado raíz y clave privada.</p>
		</div>
		<ul>
		<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td width="12%" class="imagen">
					<img src="../../CAs/""" + self.idCA + """/candado.png" alt="" title="" border="0" height="60" width="60">
				</td>
				<td width="40%" class="preview">
					<p><strong>idCA: </strong>""" + self.idCA + """<br/><strong>Fecha de Revocación: </strong>""" + self.frd + '/' + self.frm + '/' + self.fra + """</p>
				</td>
				<td width="48%" class="enlace">
					<a href="./gestCerts.html" class=""><img src="../../images/icons/script.png" width="16" height="16" /> Gestionar Certificados</a><br/>
				  	<a href="../../../web/CAs/""" + self.idCA + """/crl.html" class=""><img src="../../images/icons/report.png" width="16" height="16" /> Lista de Revocación de Certificados</a>
				</td>
			</tr>
			</tbody>
			</table>
		</li>
		<div class="section_break"></div>
		<br/>
		<lis>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(1);'><img src="../../images/icons/application_form_magnify.png" width="16" height="16" /> Ver Configuración</a></span>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(2);'><img src="../../images/icons/script_key.png" width="16" height="16" /> Ver Certificado Raíz</a></span>
			<span><a href='javascript:seleccion(3);'><img src="../../images/icons/magifier_zoom_out.png" width="16" height="16" /> Ocultar</a></span>
		</lis>
		<lis id="op1" style="display:block;width:99%;height:100%;"><br/><br/>
			""" + cf.vistaCA() + """
		</lis>
		<lis id="op2" style="display:none;width:99%;height:100%;"><br/><br/>
			<div class="section_break"></div>
			<pre>""" + certificado + """</pre>
		</lis>
		<lis id="op3" style="display:none;width:99%;height:100%;">
			Esta opción oculta la tabla
		</lis>
		<br/><br/>
		<div class="section_break"></div>
		<table width="100%" border="0" align="center">
  		<tr>
			<td><div align="center">
				<a href='../../../CAs/""" + self.idCA + """/cacert.pem' class=""><img src="../../images/icons/script_save.png" width="16" height="16" /> Descargar Certificado Raíz</a>
			</div></td>
			<td><div align="center">
				<a href='../../../CAs/""" + self.idCA + """/private/cakey.pem' class=""><img src="../../images/icons/key.png" width="16" height="16" /> Descargar Clave Privada</a>
			</div></td>
  		</tr>
</table>
		<div class="section_break"></div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		f = open(pathDir + idCA + '.html', 'w') 		# creamos el archivo
		f.write(contenido.encode("utf-8"))
		f.close()


	def vistaCA(self):
		# SIMILAR A LA VISTA PREVIA
		pre = """
		<div class="section_break">
			<h3><u>Configuración del certificado raíz de la autoridad de certificación.</u></h3>
			<div><p>A continuación se muestran los datos suministrados por el operador y que fueron utilizados para la creación de la autoridad de certificación """ + self.idCA + """.</p></div>
		</div>
		<li id="li_1" >
			<label class="description" for="idCA">Nombre Identificador de la CA: </label>
			<div>
				""" + self.idCA + """
			</div>
		</li><br/>
		<div class="section_break">
			<h3>Datos relativos al propietario de la autoridad de certificación.</h3>
			<p>Información correspondiente a la entidad propietaria del certificado raíz de la autoridad de certificación y que responde por ella.</p>
		</div>"""

		cnCode = """
		<li id="li_3" >
			<label class="description" for="nombreCom">Nombre Común (CN): </label>
			<div>
				""" + self.cn + """
			</div>
		</li>"""

		snCode = """
		<li id="li_4" >
			<label class="description" for="apellido">Apellido (SN): </label>
			<div>
				""" + self.sn + """
			</div>
		</li>"""

		gnCode = """
		<li id="li_5" >
			<label class="description" for="sobrenombre">Sobrenombre (GN): </label>
			<div>
				""" + self.gn + """
			</div>
		</li>"""

		nsCode = """
		<li id="li_9" >
			<label class="description" for="serial">Número de Serie: </label>
			<div>
				""" + self.serial + """
			</div>
		</li>"""

		oCode = """
		<li id="li_6" >
			<label class="description" for="organizacion">Organización (O): </label>
			<div>
				""" + self.o + """
			</div>
		</li>"""

		ouCode = """
		<li id="li_7" >
			<label class="description" for="unidadOrg">Unidad Organizativa (OU): </label>
			<div>
				""" + self.ou + """
			</div>
		</li>"""

		emailCode = """
		<li id="li_10" >
			<label class="description" for="email">E-mail: </label>
			<div>
				""" + self.mail + """
			</div>
		</li>"""

		dirCode = """
		<li id="li_8" >
			<label class="description" for="direccion">Datos de Localización: </label>
		</li>"""

		locCode = """
		<li id="li_10" >
			<label class="description" for="direccion_3">Localidad: </label>
			<div>
				""" + self.loc + """
			</div>
		</li>"""

		estCode = """
		<li id="li_10" >
			<label class="description" for="direccion_4">Estado / Provincia / Región: </label>
			<div>
				""" + self.st + """
			</div>
		</li>"""

		paisCode = """
		<li id="li_10" >
			<label class="description" for="direccion_6">País: </label>
			<div>
				""" + self.pais + """
			</div>
		</li>"""

		pos = """
		<br/><div class="section_break">
			<h3>Configuración del par de claves RSA del certificado raíz de la autoridad de certificación.</h3>
			<p>A continuación se muestran las opciones elegidas durante el proceso de creación del certificado raíz de la Autoridad referentes al par de claves RSA.</p>
		</div>
		<li id="li_12" >
			<label class="description" for="numBitsPK">Número de bits de la Clave Privada: </label>
			<div>
				""" + self.nBits + """
			</div>
		</li>
		<li id="li_13" >
			<label class="description" for="exponente">Exponente: </label>
			<div>
				""" + self.exp + """
			</div>
		</li>
		<li id="li_14" >
			<label class="description" for="password">Password: </label>
			Por razones de seguridad el password se mantiene oculto por defecto, si desea verlo pulse sobre el siguiente enlace: <a href="#" onclick="mostrar(this); return false" />Mostrar Password</a>.
			<div id="oculto" style="visibility:hidden">
				Password: """ + self.passw + """
			</div>
		</li>
		<li id="li_25" >
			<label class="description" for="firma">Algoritmo de Firma: </label>
			<div>
				""" + self.firma + """
			</div>
		</li><br>
		<div class="section_break">
			<h3>Fecha de caducidad de la autoridad de certificación.</h3>
			<p>El certificado raíz y por tanto la propia autoridad de certificación serán funcionales hasta la siguiente fecha.</p>
		</div>
		<li id="li_17" >
			<label class="description" for="fechaCaduc">Fecha de Caducidad: </label>
			<div>
				""" + self.frd + '/' + self.frm + '/' + self.fra + """
			</div>
		</li>"""

		vista = pre
		if self.cn != '':
			vista += cnCode
		if self.sn != '':
			vista += snCode
		if self.gn != '':
			vista += gnCode
		if self.serial != '':
			vista += nsCode
		if self.o != '':
			vista += oCode
		if self.ou != '':
			vista += ouCode
		if self.mail != '':
			vista += emailCode
		if self.loc != '' or self.st != '' or self.pais != '':
			vista += dirCode
		if self.loc != '':
			vista += locCode
		if self.st != '':
			vista += estCode
		if self.pais != '':
			vista += paisCode
		vista += pos
		return vista


	def generaRespHtml(self, cert):
		""" Pagina html que se mostrara tras rellenar el formulario de creacion de la CA.
		"""
		# dando formato html al certificado
		certificado = cert.as_text()
		# certFormat = certificado.replace('\n', '<br>')
		html = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema gestionador de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="../web/estiloInd.css" media="all">
	<script type="text/javascript" src="../web/view.js"></script>
</head>
<body id="main_body" >
	<img id="top" src="../web/images/top.png" alt="">
	<img src="../web/images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../web/index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Autoridad de Certificación Creada con Éxito.</h2>
			<p>A continuación puede ver el certificado raíz de la autoridad de certificación en formato texto, en la parte iniferior dispone de enlaces de descarga para el mismo y para su clave privada RSA.</p>
		</div>
		<ul>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div align="left"><a href="../web/index.html"><img src="../web/images/icons/house.png" width="16" height="16" /> Volver al Inicio</a></div></td>
				<td><div align="right"><a href='../web/CAs/""" + self.idCA + """/""" + self.idCA + """.html'/>Ir a Información General de la CA <img src="../web/images/icons/building.png" width="16" height="16" /></a></div></td>
				</tr>
			</tbody>
			</table>
		<div class="section_break"></div>
		<li>
			<pre>""" + certificado + """</pre>
		</li>
		<div class="section_break"></div>
		<table width="100%" border="0" align="center">
		<tbody>
 		<tr>
    		<td><div align="center"><a href='../../../CAs/""" + self.idCA + """/cacert.pem' class=""><img src="../web/images/icons/script_save.png" width="16" height="16" /> Descargar Certificado Raiz</a></div></td>
			<td><div align="center"><a href='../../../CAs/""" + self.idCA + """/private/cakey.pem' class=""><img src="../web/images/icons/key.png" width="16" height="16" /> Descargar Clave Privada</a></div></td>
 		</tr>
		</tbody>
		</table>
		<div class="section_break"></div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../web/images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		print html.encode("utf-8")


	def generaFormNC (self):
		# directorio donde guadaremos formNC.html
		dirAct = os.getcwd()
		pathDir = dirAct + '/web/CAs/' + self.idCA + '/'
		f = open(pathDir + 'formNC.html', 'w') # creamos el archivo

		htmlCode = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Nuevo Certificado Digital, Autoridad de Certificación Emisora: """ + self.idCA + """.</title>
	<link rel="stylesheet" type="text/css" href="../../style.css" media="all">
	<script type="text/javascript" src="../../view.js"></script>
	<script type="text/javascript" src="../../calendar.js"></script>
	<script languaje="javascript">
	function confirmarBorrado(form)
	{
		borrar = window.confirm('Se borrarán todos los datos del formulario.');
		(borrar)?form.reset():'return false';
	}
	</script>
	<script languaje="javascript">
	function validar(form)
	{
		mensError = ''
		formCorrecto = true
		// Comprobamos si se ha introducido el Nombre Común (CN)
		if(form.comName.value == ''){
			mensError += "ERROR: no puede dejar el campo: Nombre Común en blanco.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido el Apellido (SN)
		if(form.surname.value == ''){
			mensError += "ERROR: no puede dejar el campo: Apellido en blanco.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido la Organización (O)
		if(form.org.value == ''){
			mensError += "ERROR: no puede dejar el campo: Organización en blanco.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido la Unidad de la Organización (OU)
		if(form.uniOrg.value == ''){
			mensError += "ERROR: no puede dejar el campo: Unidad de la Organización en blanco.\\n"
			formCorrecto = false
		}
		// Comprobando que se ha introducido el email
		if(form.emaCont.value == ''){
			mensError += "ERROR: es obligatorio introducir el Email del cliente.\\n"
			formCorrecto = false
		}
		// Control del formato del email
		if (form.emaCont.value != ''){
			if (!(/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(form.emaCont.value))){
				mensError += "ERROR: el formato del email no es correcto.\\n"
				formCorrecto = false
			}
		}
		// Comprobamos si se han introducido los Datos de Localización
		if((form.ciudad.value == '') || (form.provincia.value == '') || (form.pais.value == '')){
			mensError += "ERROR: debe rellenar completamente los Datos de Localización.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido el password
		if(form.password.value == ''){
			mensError += "ERROR: debe establecer un password.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido la verificación del password
		if(form.vPassword.value == ''){
			mensError += "ERROR: debe verificar el password.\\n"
			formCorrecto = false
		}
		// Comprobamos que coincidan
		if(form.password.value != form.vPassword.value){
			mensError += "ERROR: No coinciden las claves.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido el uso del certificado
		if(form.uso.value == ''){
			mensError += "ERROR: debe establecer un uso.\\n"
			formCorrecto = false
		}
		// Comprobación de que se han rellenado los tres campos de la fecha de caducidad
		if (form.fechaCaduc_1.value == '' || form.fechaCaduc_2.value == '' || form.fechaCaduc_3.value == ''){
			mensError += "ERROR: debe elegir una fecha de caducidad.\\n"
			formCorrecto = false
		}
		// Comprobando que la fecha introducida es posterior a la actual
		if (form.fechaCaduc_1.value != '' && form.fechaCaduc_2.value != '' && form.fechaCaduc_3.value != ''){
			fechaActual = new Date()
			cadFechaIntro = form.fechaCaduc_2.value + '/' + form.fechaCaduc_1.value + '/' + form.fechaCaduc_3.value
			fechaInt = new Date(cadFechaIntro)
			if (fechaInt < fechaActual){
				mensError += "ERROR: la fecha de caducidad debe ser posterior a la actual.\\n"
				formCorrecto = false
			}
		}
		if (!formCorrecto)
			alert(mensError)
		return formCorrecto
	}
	</script>
</head>
<body id="main_body" >
	<img id="top" src="../../images/top.png" alt="">
	<img src="../../images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../../index.html" /></map>
	<div id="form_container">
		<br>
		<form id="form_43076" class="appnitro"  method="post" action="http://localhost:8000/cgi-bin/prevNC.py" onSubmit = "return validar(this)">
		<div class="form_description">
			<h2>Nuevo Certificado Digital.</h2>
			<p>El siguiente formulario le permite generar un <B>nuevo certificado digital</B> firmado por la autoridad de certificación <B>""" + self.idCA + """</B>.</p>
		<ul>
			<input id="idCA" name="idCA" class="element text medium" type="hidden" maxlength="255" value='""" + self.idCA + """' readonly/> 
			<input id="passwCA" name="passwCA" class="element text medium" type="hidden" maxlength="255" value='""" + self.passw + """' readonly/>	
		<li class="section_break">
			<h3>Información del Cliente</h3>
			<p>Rellene los siguientes campos con la información del cliente.</p>
		</li>
		<li id="li_2" >
			<label class="description" for="comName">*Nombre Común (CN): </label>
			<div>
				<input id="comName" name="comName" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_2"><small>Este campo se utiliza para identificar comúnmente a la persona, empresa u organización que poseerá el certificado.</small></p> 
		</li>
		<li id="li_3" >
			<label class="description" for="surname">*Apellido (SN): </label>
			<div>
				<input id="surname" name="surname" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_3"><small>Úsese en el caso en que el cliente sea una persona.</small></p> 
		</li>
		<li id="li_4" >
			<label class="description" for="givName">Sobrenombre (GN): </label>
			<div>
				<input id="givName" name="givName" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_4"><small>Posible segundo nombre o sobrenombre si existiese.</small></p>
		</li>
		<li id="li_5" >
			<label class="description" for="serial">Número de Serie: </label>
			<div>
				<input id="serial" name="serial" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_5"><small>Código alfanumérico que identifique de alguna manera al cliente.</small></p> 
		</li>
		<li id="li_6" >
			<label class="description" for="org">*Organización (O): </label>
			<div>
				<input id="org" name="org" class="element text large" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_6"><small>Por ejemplo: el nombre de una compañía.</small></p>
		</li>
		<li id="li_7" >
			<label class="description" for="uniOrg">*Unidad Organizativa (OU): </label>
			<div>
				<input id="uniOrg" name="uniOrg" class="element text large" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_7"><small>Le permite diferenciar varias partes de una misma organización.</small></p>
		</li>
		<li id="li_8" >
			<label class="description" for="emaCont">*Email: </label>
			<div>
				<input id="emaCont" name="emaCont" class="element text large" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_8"><small>Dirección de correo electrónico de contacto.</small></p> 
		</li>
		<li id="li_9" >
			<label class="description" for="loc">*Datos de Localización: </label>
			<div class="left">
				<input id="ciudad" name="ciudad" class="element text medium" value="" type="text">
				<label for="ciudad">Ciudad</label>
			</div>	
			<div class="right">
				<input id="provincia" name="provincia" class="element text medium" value="" type="text">
				<label for="provincia">Estado / Provincia / Región</label>
			</div>
			<div class="left">
				<select class="element select medium" id="pais" name="pais"> 
					<option value="" selected="selected"></option>
					<option value="ES"> Spain</option>
					<option value="US"> United States of America</option>
					<option value="CA"> Canada</option>
					<option value="AX"> Aland Islands</option>
					<option value="AD"> Andorra</option>
					<option value="AE"> United Arab Emirates</option>
					<option value="AF"> Afghanistan</option>
					<option value="AG"> Antigua and Barbuda</option>
					<option value="AI"> Anguilla</option>
					<option value="AL"> Albania</option>
					<option value="AM"> Armenia</option>
					<option value="AN"> Netherlands Antilles</option>
					<option value="AO"> Angola</option>
					<option value="AQ"> Antarctica</option>
					<option value="AR"> Argentina</option>
					<option value="AS"> American Samoa</option>
					<option value="AT"> Austria</option>
					<option value="AU"> Australia</option>
					<option value="AW"> Aruba</option>
					<option value="AZ"> Azerbaijan</option>
					<option value="BA"> Bosnia and Herzegovina</option>
					<option value="BB"> Barbados</option>
					<option value="BD"> Bangladesh</option>
					<option value="BE"> Belgium</option>
					<option value="BF"> Burkina Faso</option>
					<option value="BG"> Bulgaria</option>
					<option value="BH"> Bahrain</option>
					<option value="BI"> Burundi</option>
					<option value="BJ"> Benin</option>
					<option value="BM"> Bermuda</option>
					<option value="BN"> Brunei Darussalam</option>
					<option value="BO"> Bolivia</option>
					<option value="BR"> Brazil</option>
					<option value="BS"> Bahamas</option>
					<option value="BT"> Bhutan</option>
					<option value="BV"> Bouvet Island</option>
					<option value="BW"> Botswana</option>
					<option value="BY"> Belarus</option>
					<option value="BZ"> Belize</option>
					<option value="CA"> Canada</option>
					<option value="CC"> Cocos (Keeling) Islands</option>
					<option value="CF"> Central African Republic</option>
					<option value="CG"> Congo</option>
					<option value="CD"> Congo, Democratic Republic of the</option>
					<option value="CH"> Switzerland</option>
					<option value="CI"> Cote D'Ivoire (Ivory Coast)</option>
					<option value="CK"> Cook Islands</option>
					<option value="CL"> Chile</option>
					<option value="CM"> Cameroon</option>
					<option value="CN"> China</option>
					<option value="CO"> Colombia</option>
					<option value="CR"> Costa Rica</option>
					<option value="CS"> Czechoslovakia (former)</option>
					<option value="CU"> Cuba</option>
					<option value="CV"> Cape Verde</option>
					<option value="CX"> Christmas Island</option>
					<option value="CY"> Cyprus</option>
					<option value="CZ"> Czech Republic</option>
					<option value="DE"> Germany</option>
					<option value="DJ"> Djibouti</option>
					<option value="DK"> Denmark</option>
					<option value="DM"> Dominica</option>
					<option value="DO"> Dominican Republic</option>
					<option value="DZ"> Algeria</option>
					<option value="EC"> Ecuador</option>
					<option value="EE"> Estonia</option>
					<option value="EG"> Egypt</option>
					<option value="EH"> Western Sahara</option>
					<option value="ER"> Eritrea</option>
					<option value="ET"> Ethiopia</option>
					<option value="FI"> Finland</option>
					<option value="FJ"> Fiji</option>
					<option value="FK"> Falkland Islands (Malvinas)</option>
					<option value="FM"> Micronesia</option>
					<option value="FO"> Faroe Islands</option>
					<option value="FR"> France</option>
					<option value="FX"> France, Metropolitan</option>
					<option value="GA"> Gabon</option>
					<option value="GB"> Great Britain (UK)</option>
					<option value="GD"> Grenada</option>
					<option value="GE"> Georgia</option>
					<option value="GF"> French Guiana</option>
					<option value="GG"> Guernsey GH Ghana</option>
					<option value="GI"> Gibraltar</option>
					<option value="GL"> Greenland</option>
					<option value="GM"> Gambia</option>
					<option value="GN"> Guinea</option>
					<option value="GP"> Guadeloupe</option>
					<option value="GQ"> Equatorial Guinea</option>
					<option value="GR"> Greece</option>
					<option value="GS"> S. Georgia and S. Sandwich Isls.</option>
					<option value="GT"> Guatemala</option>
					<option value="GU"> Guam</option>
					<option value="GW"> Guinea-Bissau</option>
					<option value="GY"> Guyana</option>
					<option value="HK"> Hong Kong</option>
					<option value="HM"> Heard and McDonald Islands</option>
					<option value="HN"> Honduras</option>
					<option value="HR"> Croatia (Hrvatska)</option>
					<option value="HT"> Haiti</option>
					<option value="HU"> Hungary</option>
					<option value="ID"> Indonesia</option>
					<option value="IE"> Ireland</option>
					<option value="IL"> Israel</option>
					<option value="IM"> Isle of Man</option>
					<option value="IN"> India</option>
					<option value="IO"> British Indian Ocean Territory</option>
					<option value="IQ"> Iraq</option>
					<option value="IR"> Iran</option>
					<option value="IS"> Iceland</option>
					<option value="IT"> Italy</option>
					<option value="JE"> Jersey</option>
					<option value="JM"> Jamaica</option>
					<option value="JO"> Jordan</option>
					<option value="JP"> Japan</option>
					<option value="KE"> Kenya</option>
					<option value="KG"> Kyrgyzstan</option>
					<option value="KH"> Cambodia</option>
					<option value="KI"> Kiribati</option>
					<option value="KM"> Comoros</option>
					<option value="KN"> Saint Kitts and Nevis</option>
					<option value="KP"> Korea (North)</option>
					<option value="KR"> Korea (South)</option>
					<option value="KW"> Kuwait</option>
					<option value="KY"> Cayman Islands</option>
					<option value="KZ"> Kazakhstan</option>
					<option value="LA"> Laos</option>
					<option value="LB"> Lebanon</option>
					<option value="LC"> Saint Lucia</option>
					<option value="LI"> Liechtenstein</option>
					<option value="LK"> Sri Lanka</option>
					<option value="LR"> Liberia</option>
					<option value="LS"> Lesotho</option>
					<option value="LT"> Lithuania</option>
					<option value="LU"> Luxembourg</option>
					<option value="LV"> Latvia</option>
					<option value="LY"> Libya</option>
					<option value="MA"> Morocco</option>
					<option value="MC"> Monaco</option>
					<option value="MD"> Moldova</option>
					<option value="ME"> Montenegro</option>
					<option value="MG"> Madagascar</option>
					<option value="MH"> Marshall Islands</option>
					<option value="MK"> Macedonia</option>
					<option value="ML"> Mali</option>
					<option value="MM"> Myanmar</option>
					<option value="MN"> Mongolia</option>
					<option value="MO"> Macau</option>
					<option value="MP"> Northern Mariana Islands</option>
					<option value="MQ"> Martinique</option>
					<option value="MR"> Mauritania</option>
					<option value="MS"> Montserrat</option>
					<option value="MT"> Malta</option>
					<option value="MU"> Mauritius</option>
					<option value="MV"> Maldives</option>
					<option value="MW"> Malawi</option>
					<option value="MX"> Mexico</option>
					<option value="MY"> Malaysia</option>
					<option value="MZ"> Mozambique</option>
					<option value="NA"> Namibia</option>
					<option value="NC"> New Caledonia</option>
					<option value="NE"> Niger</option>
					<option value="NF"> Norfolk Island</option>
					<option value="NG"> Nigeria</option>
					<option value="NI"> Nicaragua</option>
					<option value="NL"> Netherlands</option>
					<option value="NO"> Norway</option>
					<option value="NP"> Nepal</option>
					<option value="NR"> Nauru</option>
					<option value="NT"> Neutral Zone</option>
					<option value="NU"> Niue</option>
					<option value="NZ"> New Zealand (Aotearoa)</option>
					<option value="OM"> Oman</option>
					<option value="PA"> Panama</option>
					<option value="PE"> Peru</option>
					<option value="PF"> French Polynesia</option>
					<option value="PG"> Papua New Guinea</option>
					<option value="PH"> Philippines</option>
					<option value="PK"> Pakistan</option>
					<option value="PL"> Poland</option>
					<option value="PM"> St. Pierre and Miquelon</option>
					<option value="PN"> Pitcairn</option>
					<option value="PR"> Puerto Rico</option>
					<option value="PS"> Palestinian Territory</option>
					<option value="PT"> Portugal</option>
					<option value="PW"> Palau</option>
					<option value="PY"> Paraguay</option>
					<option value="QA"> Qatar</option>
					<option value="RE"> Reunion</option>
					<option value="RO"> Romania</option>
					<option value="RS"> Serbia RU Russian Federation</option>
					<option value="RW"> Rwanda</option>
					<option value="SA"> Saudi Arabia</option>
					<option value="SB"> Solomon Islands</option>
					<option value="SC"> Seychelles</option>
					<option value="SD"> Sudan</option>
					<option value="SE"> Sweden</option>
					<option value="SG"> Singapore</option>
					<option value="SH"> St. Helena</option>
					<option value="SI"> Slovenia</option>
					<option value="SJ"> Svalbard and Jan Mayen Islands</option>
					<option value="SK"> Slovak Republic</option>
					<option value="SL"> Sierra Leone</option>
					<option value="SM"> San Marino</option>
					<option value="SN"> Senegal</option>
					<option value="SO"> Somalia</option>
					<option value="SR"> Suriname</option>
					<option value="ST"> Sao Tome and Principe</option>
					<option value="SU"> USSR (former)</option>
					<option value="SV"> El Salvador</option>
					<option value="SY"> Syria</option>
					<option value="SZ"> Swaziland</option>
					<option value="TC"> Turks and Caicos Islands</option>
					<option value="TD"> Chad</option>
					<option value="TF"> French Southern Territories</option>
					<option value="TG"> Togo</option>
					<option value="TH"> Thailand</option>
					<option value="TJ"> Tajikistan</option>
					<option value="TK"> Tokelau</option>
					<option value="TM"> Turkmenistan</option>
					<option value="TN"> Tunisia</option>
					<option value="TO"> Tonga</option>
					<option value="TP"> East Timor</option>
					<option value="TR"> Turkey</option>
					<option value="TT"> Trinidad and Tobago</option>
					<option value="TV"> Tuvalu</option>
					<option value="TW"> Taiwan</option>
					<option value="TZ"> Tanzania</option>
					<option value="UA"> Ukraine</option>
					<option value="UG"> Uganda</option>
					<option value="UM"> US Minor Outlying Islands</option>
					<option value="US"> United States</option>
					<option value="UY"> Uruguay</option>
					<option value="UZ"> Uzbekistan</option>
					<option value="VA"> Vatican City State (Holy See)</option>
					<option value="VC"> Saint Vincent and the Grenadines</option>
					<option value="VE"> Venezuela</option>
					<option value="VG"> Virgin Islands (British)</option>
					<option value="VI"> Virgin Islands (U.S.)</option>
					<option value="VN"> Viet Nam</option>
					<option value="VU"> Vanuatu</option>
					<option value="WF"> Wallis and Futuna Islands</option>
					<option value="WS"> Samoa</option>
					<option value="YE"> Yemen</option>
					<option value="YT"> Mayotte</option>
					<option value="ZA"> South Africa</option>
					<option value="ZM"> Zambia</option>
					<option value="ZW"> Zimbabwe</option>
				</select>
			<label for="pais">País</label>
			</div><p class="guidelines" id="guide_8"><small>Rellene con los datos de localización habitual del cliente.</small></p> 
		</li>
		<li class="section_break">
			<h3>Gestión de Extensiones.</h3>
			<p>Durante la generación de un certificado debe decidir qué extensiones incorporar al mismo.</p> 
			<p>	Seleccione uno de los usos definidos en la siguiente lista para que se incluyan una serie de extensiones por defecto asociadas al mismo.</p>
			<p>	# TODO Si desea configurar manualmente las extensiones del certificado, marque la opción por defecto: "Otros" termine de rellenar correctamente este formulario y pulse Enviar, a continuación dispondrá de una interfaz de gestión manual de extensiones que le permitirá configurarlas.</p>
		</li>
		<li id="li_16" >
			<label class="description" for="uso">*Usos del certificado: </label>
			<div class="left">
				<select class="element select medium" id="uso" name="uso">
					<option value=1> SSL Client</option>
					<option value=2> SSL Client CA</option>
					<option value=3> SSL Server</option>
					<option value=4> SSL Server CA</option>
					<option value=5> Netscape SSL Server</option>
					<option value=6> S/MIME Signing</option>
					<option value=7> S/MIME Encryption</option>
					<option value=8> S/MIME CA</option>
					<option value=9> CRL Signing</option>
					<option value=10> CRL Signing CA</option>
				</select>
				<p class="guidelines" id="guide_16"><small>Seleccione el uso que se le dará al certificado digital.</small></p>
			</div> 
		</li>
		<li class="section_break">
			<h3>Claves Pública y Privada.</h3>
			<p>Datos necesarios para generar el par de claves RSA asociadas al Certificado Digital.</p>
		</li>
		<li id="li_17" >
			<label class="description" for="numBits">Número de bits de la Clave Privada: </label>
			<div>
			<select class="element select medium" id="numBits" name="numBits"> 
				<option value="0" >512</option>
				<option value="1" selected="selected">1024</option>
				<option value="2" >2048</option>
				<option value="3" >3072</option>
				<option value="4" >4096</option>
		</select>
		</div><p class="guidelines" id="guide_17"><small>En caso de duda se recomienda mantener el valor por defecto.</small></p> 
		</li>
		<li id="li_18" >
			<label class="description" for="exp">Exponente: </label>
			<div>
			<select class="element select medium" id="exp" name="exp"> 
				<option value="1" >RSA_3 (0x03L)</option>
				<option value="2" selected="selected">RSA_F4 (0x10001L)</option>
			</select>
			</div><p class="guidelines" id="guide_18"><small>En caso de duda se recomienda mantener el valor por defecto.</small></p> 
		</li>
		<li id="li_12" >
			<label class="description" for="password">*Password: </label>
			<div>
				<input id="password" name="password" class="element text large" type="password" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_12"><small>El password será utilizado para encriptar la clave privada y para generar nuevos certificados y firmar listas de revocación en caso de que el certificado se use como certificado raiz de una autoridad de certificación.</small></p>
		</li>
		<li id="li_13" >
			<label class="description" for="vPassword">*Verificación del Password: </label>
			<div>
				<input id="vPassword" name="vPassword" class="element text large" type="password" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_13"><small>Vuelva a escribir el password anterior.</small></p> 
		</li>
		<li id="li_19">
			<label class="description" for="firma">*Algoritmo de Firma: </label>
			<div>
			<select class="element select medium" id="firma" name="firma"> 
				<option value="md5" >MD5</option>
				<option value="sha1" selected="selected">SHA1 (DSS1)</option>
				<option value="sha224" >SHA224</option>
				<option value="sha256" >SHA256</option>
				<option value="ripemd160" >RIPEMD-160</option>
			</select>
			</div><p class="guidelines" id="guide_19"><small>Se recomienda usar SHA1 y RIPEMD-160, seleccione MD5 solo en caso de necesidad de compatibilidad software.</small></p> 
		</li>
		<li class="section_break">
			<h3>Validez del Certificado</h3>
			<p>El certificado será válido a partir del momento de emisión hasta la fecha que elija a continuación.</p>
		</li>		
		<li id="li_15" >
			<label class="description" for="fechaCaduc">*Fecha de Caducidad: </label>
			<span>
				<input id="fechaCaduc_1" name="fechaCaduc_1" class="element text" size="2" maxlength="2" value="" type="text"> /
				<label for="fechaCaduc_1">DD</label>
			</span>
			<span>
				<input id="fechaCaduc_2" name="fechaCaduc_2" class="element text" size="2" maxlength="2" value="" type="text"> /
				<label for="fechaCaduc_2">MM</label>
			</span>
			<span>
		 		<input id="fechaCaduc_3" name="fechaCaduc_3" class="element text" size="4" maxlength="4" value="" type="text">
				<label for="fechaCaduc_3">AAAA</label>
			</span>
	
			<span id="calendar_15">
				<img id="cal_img_15" class="datepicker" src="../../images/calendar.gif" alt="Seleccione una fecha.">	
			</span>
			<script type="text/javascript">
				Calendar.setup({
				inputField	 : "fechaCaduc_3",
				baseField    : "fechaCaduc",
				displayArea  : "calendar_15",
				button		 : "cal_img_15",
				ifFormat	 : "%B %e, %Y",
				onSelect	 : selectEuropeDate
				});
			</script>
			<p class="guidelines" id="guide_15"><small>Último día de validez del certificado.</small></p> 
		</li>
		<li class="buttons">
		    <input type="hidden" name="form_id" value="43076" />
		    <input type="button" value="Borrar" onClick="confirmarBorrado(this.form)" />
			<input id="saveForm" class="button_text" type="submit" name="submit" value="Enviar" />
		</li>
		</ul>
		</div>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')

		f.write(htmlCode.encode("utf-8"))
		f.close()


def crearEst (dirRaiz, idCA):
	"""Comprueba que no exista el fichero idCA en el directorio dirRaiz, 
	en caso afirmativo devuelve False, en caso negativo crea los archivos y 
	la estructura de ficheros necesaria para una nueva CA de nombre 
	idCA colgando del directorio dirRaiz.

	@type dirRaiz: string
	@param dirRaiz: directorio del que cuelgan las ficheros con el contenido 
					de cada CA.

	@type idCA: string
	@param idCA: nombre del fichero que contendrá los archivos y ficheros 
				necesarios para una CA y coincide con el nombre asignado a 
				la CA en el formulario asociado.
	"""
	
	yaExisteCA = False				# variable que indica si ya existe CA con el mismo idCA
	if os.access(dirRaiz, os.W_OK): # comprobamos si existe y podemos escribir en dirRaiz
		dirCAs = dirRaiz + '/CAs/'		
		dirCA = dirCAs + idCA + '/'

		if os.access(dirCAs, os.F_OK) == False:
			os.mkdir(dirCAs, 0777)

		if os.access(dirCA, os.F_OK) == False:
			os.mkdir(dirCA, 0777)
			# crear los directorios /certs y /private
			os.mkdir(dirCA + "certs", 0777)
			os.mkdir(dirCA + "private", 0700)

			#creación del archivo serial
			serial = open(dirCA + "serial", 'w')
			serial.write('1')
			serial.close()
		else:
			yaExisteCA = True
	return yaExisteCA

	    #creación del archivo track de certificados
#		ind = open(dirCA + "index.txt", 'w')
#		ind.close()


def generateRSAKey(pkb=2048, e=m2.RSA_F4):
	"""Genera un nuevo par de claves RSA.
	La seguridad de esta clave impacta directamente en la seguridad
	de todas las claves emitidas por esta CA. 

	@type pkb: int
	@param pkb: especifica el número de bits en el módulo público, 
	minimo 1024, recomendables 2048.
	@type e: hex long
	@param e: valor a utilizar por el exponente público, 
	recomendable utilizar las constantes openSSL RSA_3 (0x03L) o 
	RSA_F4 

	@rtype: M2Crypto.RSA.RSA
	@return: M2Crypto.RSA.RSA object.
	"""

#	XXX Captura de formulario:
#	pkdf(private key bits)
#	e(RSA_3 = 0x03L o RSA_F4 = 0x10001L)
#	return RSA.gen_key(pkb, e)
	pPKey = RSA.gen_key(pkb, e)
	while pPKey == 0:
		print "Error: La clave RSA generada no es correcta. Generando otra..."
		pPKey = RSA.gen_key(pkb, e)
	check = pPKey.check_key()
	if check == -1:
		print "Ha habido un problema durante la comprobacion de la clave RSA."
	return pPKey


def makePKey(key):
    """Recibe un par de claves RSA y devuelve la componente pública.

       @type key: M2Crypto.RSA.RSA
       @param key: par de claves RSA 

       @rtype: M2Crypto.EVP.Pkey
       @return: M2Crypto.EVP.Pkey object.
    """

    pkey = EVP.PKey()
    pkey.assign_rsa(key)
    return pkey


def makeRequest(pkey, datForm):
    """Crea una petición de certificado X.509 (X.509 Certificate Request).
    
       @type pkey: M2Crypto.EVP.Pkey
       @param pkey: componente pública de par de claves RSA 
    """

    req = X509.Request()
    req.set_pubkey(pkey)
    name = X509.X509_Name()
    
    # Registro del subject name (para identificar al receptor del certificado)
    name.CN = datForm.cn
    name.SN = datForm.sn
    name.GN = datForm.gn
    name.C = datForm.pais
    name.ST = datForm.st
    name.L = datForm.loc
    name.O = datForm.o
    name.OU = datForm.ou
    name.Email = datForm.mail
    name.serialNumber = datForm.serial
    
    req.set_subject_name(name)

    # Gestion de extensiones en la solicitud del certificado
# XXX Cuando creamos el certificado autofirmado para la CA permitimos que pueda tener infinitos certificados raices encadenados
# XXX Cuando creemos certificados para CAs para usuarios si que se establece el parametro pathlen
# XXX XXX REFERENCIA FUNDAMENTAL http://www.openssl.org/docs/apps/x509v3_config.html
#   ext1 = X509.new_extension('basicConstraints', 'CA:true, pathlen:1')
    ext1 = X509.new_extension('basicConstraints', 'CA:true', 1) # el 1 indica que la extensión es crítica
    extstack = X509.X509_Extension_Stack()
    extstack.push(ext1)
    # Comprobacion del contenido de la pila
    assert(extstack[0].get_name() == 'basicConstraints')
    req.add_extensions(extstack)
    # Fin del tratamiento de inclusion de extensiones

    # Firma de la peticion
    algFirma = datForm.firma
    req.sign(pkey, algFirma)
    return req


def makeCert(req, caPkey, dias, datForm):
	"""Crea el certificado autofirmado de la CA a partir del
	certifique request, la clave RSA y el número de días de validez.
	"""
	
	pkey = req.get_pubkey()
	if not req.verify(pkey):
		raise ValueError, "Error verificando la clave pública de la petición."
	sub = req.get_subject()

    # IMPORTANTE:
    # If this were a real certificate request, ***you would display
    # all the relevant data from the request and ask a human operator
    # if you were sure.*** Now we just create the certificate blindly based
    # on the request.
	cert = X509.X509()
    # We know we are making CA cert now...
    # XXX Me raya que el numero de serie es 1 (0x1), cuando en el libro 
    # para el certificado de la CA es 0 (0x0)
    # Número de serie por defecto es 0.
    # cert.set_serial_number(1)
	cert.set_version(2)
	cert.set_subject(sub)

    # Se trata de un certificado autofirmado => el emisor y el receptor son la misma entidad
	issuer = req.get_subject()
	cert.set_issuer(issuer)
	cert.set_pubkey(pkey)
	notBefore = m2.x509_get_not_before(cert.x509)
	notAfter  = m2.x509_get_not_after(cert.x509)
	m2.x509_gmtime_adj(notBefore, 0)
	m2.x509_gmtime_adj(notAfter, 60*60*24*dias) # Periodo de validez

	# Gestión de extensiones:
    # el tercer argumento a 1 indica que la extensión es crítica
	cert.add_ext(X509.new_extension('basicConstraints', 'CA:true', 1))

	# Firma del certificado
#	cert.sign(caPkey, 'md2')
#	cert.sign(caPkey, 'md4')
#	cert.sign(caPkey, 'md5') -
#	cert.sign(caPkey, 'mdc2')
#	cert.sign(caPkey, 'sha1') -
#	cert.sign(caPkey, 'dss1') # 'dss1' es una notación distinta para el mismo 'sha1'
#	cert.sign(caPkey, 'ripemd160') -
	algFirma = datForm.firma
	cert.sign(caPkey, algFirma)
	return cert


if __name__ == '__main__':
	
	cf = CFormulario()
	# Parte correspondiente a la generación de la estructura de directorios y archivos
	dirAct = os.getcwd()
	if (crearEst(dirAct, cf.idCA)):
		print "Content-Type: text/html\n"     # sigue HTML y linea en blanco indicando fin de la cabecera
		print "ERROR: No se ha creado la autoridad de certificación porque ya existe una con ese identificador. <br/>Por favor vuelva a iniciar el proceso elijiendo un identificador diferente."
	else:
		#	Parte correspondiente a la generación del par de claves RSA:
		dirCA = dirAct + '/CAs/' + cf.idCA
		dirCAPrivate = dirCA + '/private/'
	#	print "Generando claves..."

		# Creación del par de claves
		numBits = int(cf.nBits)
		exp = cf.exp
		if exp == "RSA_3 (0x03L)":
			exp = m2.RSA_3
		else:
			exp = m2.RSA_F4
	#	print "<br> GENERANDO CLAVES RSA... "
		rsa = generateRSAKey(numBits, exp)
		rsa.save_key(dirCAPrivate + 'cakey.pem', 'aes_256_cbc', cf.web_passphrase_callback)

		print "Content-Type: text/html\n"     # sigue HTML y linea en blanco indicando fin de la cabecera
		# Creación del certificado digital
		pkey = makePKey(rsa)
		req = makeRequest(pkey, cf) # genera la petición
		dias = cf.diasValidez()
		cert = makeCert(req, pkey, dias, cf) # crea el certificado
	#	print "<br> IMPRESIÓN DE LA PETICIÓN: <br>"
	#	print req.as_text()
	#	print "<br> IMPRESIÓN DEL CERTIFICADO as_text: <br>"
	#	print cert.as_text()
	#	print "<br> IMPRESIÓN DEL CERTIFICADO as_pem: <br>"
	#	print cert.as_pem()
		cert.save_pem(dirCA + '/cacert.pem')
		cert.save_pem(dirCA + '/certs/0.pem')	# creamos una copia en /certs
	#	cert.save(dirCA + 'cacert.der', 0) # vamos a probar a guardarlo tb en .DER

	# XXX XXX XXX MODIFICACION 31 JULIO XXX XXX XXX
		xCert = _xml.XMLCA(dirAct + '/web/CAs/CAs.xml')

		# comprueba si existe el archivo CAs.xml y en caso negativo lo crea
		if not os.path.exists(dirAct + '/web/CAs/CAs.xml'):
			xCert.crear()

		_xml.XMLCA.actualiza (xCert, cf)
	# XXX XXX XXX MODIFICACION 31 JULIO XXX XXX XXX

		# Crear /web/CAs/idCA/idCA.html (idCA es el id de la CA)
		cf.crearCAHtml()

	# XXX XXX XXX MODIFICACION 5 AGOSTO XXX XXX XXX
		# Crear /web/CAs/idCA/crl.html
#		cf.crearCRLHtml()
	# XXX XXX XXX MODIFICACION 5 AGOSTO XXX XXX XXX

	#	# Actualizamos index.html	# El index.html obtiene la información de /web/CAs/CAs.xml
	#	cf.actualizaIndex()

		# Creamos el formulario html para emitir certificados
		cf.generaFormNC()
		# Creamos el archivo "certs.xml"
		crearCertsXML(cf.idCA)
		# Creamos el archivo "revocados.xml"
		crearRevocadosXML(cf.idCA)


		# Creación de CRL vacía
		crlNueva = crl.crearCRLVacia (cf.idCA, cf.web_passphrase_callback, 'sha1')

	# XXX XXX XXX MODIFICACION 3 AGOSTO XXX XXX XXX
	#	crlInst = crl.CRL(cf.idCA)
	#	crlInst.crearCRLhtml(cf.idCA)
	#	crl.CRL(cf.idCA)
	# XXX XXX XXX MODIFICACION 3 AGOSTO XXX XXX XXX

	# Crear CRL
	#	X509.CRL() <- BUGAZO DE M2CRYPTO llamando a un método que no existe m2.x509_crl_new



		# Página html que mostramos como respuesta
		cf.generaRespHtml(cert)

