#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import cgi
import cgitb; cgitb.enable()
import time
import os
from M2Crypto import X509

import _xml
import crl

import sys
import traceback


def actualizaRevocadosXML(idCA, certRev):
	""" Actualización del contenido del archivo revocados.xml almacenando 
		el número de serie y fecha de revocación del certificado revocado.
	"""

	dirAct = os.getcwd()
	pathXml = dirAct + '/web/CAs/' + idCA + '/revocados.xml'
	if not os.path.exists(pathXml):
		fXml = open (pathXml, 'w')			# el archivo revocados.xml ya debería estar creado
		etiquetaRaiz = """<?xml version="1.0" encoding="UTF-8" ?>\n<revocados idCA='""" + idCA + """'>"""
		fXml.write(etiquetaRaiz)
	else:
		fXml = open (pathXml, 'r+w')		# abre el ya existente revocados.xml
		fXml.seek(-13, 2)					# desplazamos justo antes de </revocados>
	lRev = generaLRev(certRev)				# lista de cadenas con las filas de la estructura XML del certificado revocado
	lRev.append("\n</revocados>")			# restauramos la etiqueta de cierre del elemento raíz
	fXml.writelines(lRev)
	fXml.close()


def generaLRev (certRev):
	""" Recibe un certificado digital como argumento y genera una lista de 
		cadenas que conforman una estructura XML válida.
	"""
	lRev = []

	raizInicNodo = "\n\t<certificado>"
	raizFinNodo = "\n\t</certificado>"

	numSerieNodo = "\n\t\t<numSerie>" + str(certRev.getSerial()) + "</numSerie>"
	fechaRevNodo = "\n\t\t<fechaRev>" + certRev.getRevocationDate() + "</fechaRev>"

	lRev.append(raizInicNodo)
	lRev.append(numSerieNodo)
	lRev.append(fechaRevNodo)
	lRev.append(raizFinNodo)

	return lRev


def generaRespHtml(idCA, listaRevocacion):
	""" Pagina html que se mostrará tras enviar el formulario del certificado.
	"""
	# dando formato texto a la CRL
	crlTexto = listaRevocacion.crl.as_text()
	html = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Certificado Digital Revocado con Éxito.</title>
	<link rel="stylesheet" type="text/css" href="../web/estiloInd.css" media="all">
	<script type="text/javascript" src="../web/view.js"></script>
</head>
<body id="main_body" >
	<img id="top" src="../web/images/top.png" alt="">
	<img src="../web/images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../web/index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Certificado Digital Revocado con Éxito.</h2>
			<p>A continuación puede comprobar como la lista de revocación de certificados incluye el certificado recien revocado, recuerde que si desea descargarla debe hacerlo accediendo a la sección: "Lista de Revocación de Certificados".</p>
		</div>
		<ul>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div align="left"><a href="../web/CAs/""" + idCA + """/gestCerts.html"><img src="../web/images/icons/script.png" width="16" height="16" /> Volver a Gestionar Certificados</a></div></td>
				<td><div align="right"><a href="../web/CAs/""" + idCA + """/crl.html">Ir a Lista de Revocación de Certificados <img src="../web/images/icons/report.png" width="16" height="16" /></a></div></td>
				</tr>
			</tbody>
			</table>
		<div class="section_break"></div>
		<li>
			<pre>""" + crlTexto + """</pre>
		</li>
		<div class="section_break"></div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../web/images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
	print html.encode("utf-8")


class RevocarXML:

	idCA = None
	serial = None

	def __init__(self):
		form = cgi.FieldStorage(keep_blank_values=1)	# parsea la peticion, form se comporta como un diccionario
		dirAct = os.getcwd()
		self.idCA = form["idCA"].value
		ruta = 	dirAct + "/web/CAs/" + self.idCA + "/certs.xml"
		xmlObj = _xml.XMLCert(ruta)

		if form.has_key("revocado1CHB") and form["revocado1CHB"].value == "on":
			if isinstance(form["revocado1Serial"], list):
				if form.has_key("revocado1Serial") and form["revocado1Serial"][0].value != "":
					self.serial = form["revocado1Serial"][0].value
			else:
				self.serial = form["revocado1Serial"].value
			# Revocar certificado con idCA = self.idCA y número de serie = self.serial1
			xmlObj.revocar(self.serial)										# cambio del estado en el XML


	def web_passphrase_callback(self, p="", q=""):
		dirAct = os.getcwd()
		pathCAXML = dirAct + '/web/CAs/CAs.xml'
		objCAXML = _xml.XMLCA(pathCAXML)
		clave = objCAXML.getClave(self.idCA)
		return str(clave)


if __name__ == '__main__':
	print "Content-Type: text/html"     # sigue HTML
	print								# linea en blanco, fin de la cabecera
	sys.stderr = sys.stdout
	try:
		mn = RevocarXML()
		if mn.serial!=None:
			certiRevoc = crl.CertificadoRevocado()
			certiRevoc.setSerial(long(mn.serial))
			certiRevoc.setRevocationDate()
			actualizaRevocadosXML(mn.idCA, certiRevoc)			# actualizar el archivo revocados.xml
#			print "Se quiere revocar algo<br />"
			if crl.existeCRL(mn.idCA):
#				print "Ya existe una CRL <br />"
				dirAct = os.getcwd()
				lrc = X509.load_crl( dirAct + "/CAs/" + mn.idCA + "/" + mn.idCA + "PEM.crl")
				listaRevocacion= crl.CRL(lrc)

			else:
#				print "No existe ya una CRL<br />"
				listaRevocacion = crl.CRL()
				listaRevocacion.setLastUpdate()
				listaRevocacion.setNextUpdate()
				listaRevocacion.setIssuer(mn.idCA)

			listaRevocacion.addRevocado(certiRevoc.certRev)
			listaRevocacion.sign(mn.idCA, mn.web_passphrase_callback, 'sha1')
			listaRevocacion.writePem(mn.idCA)
		else:
			print "Es recomendable que active el soporte Javascript en su navegador mientras utiliza miARC.<br/> Debe marcar la casilla 'Revocar' en la página anterior en aquellos certificados que lo permitan antes de pulsar el botón 'Revocar el Certificado Seleccionado' para llevarla a cabo.<br/>"

		generaRespHtml(mn.idCA, listaRevocacion)
#		print "PAGINA DE CONFIGURACION DE LA CRL de la CA de la que se han revocado los certificados."
	except:
		print "\n\n<PRE>"
		traceback.print_exc()

