#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import cgi
import cgitb; cgitb.enable()
import os

import _xml
import lib.miarc_util
import crl
import revocar

import sys
import traceback


class RevocarCA:

	def __init__(self, idCA):
		self.idCA = idCA

	def web_passphrase_callback(self, p="", q=""):
		dirAct = os.getcwd()
		pathCAXML = dirAct + '/web/CAs/CAs.xml'
		objCAXML = _xml.XMLCA(pathCAXML)
		clave = objCAXML.getClave(self.idCA)
		return str(clave)


def generaRespHtml(idCA, listaRevocacion):
	""" Pagina html que se mostrará tras revocar la CA.
	"""
	# dando formato texto a la CRL
	crlTexto = listaRevocacion.crl.as_text()
	html = unicode("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Autoridad de Certificación Revocada con Éxito.</title>
	<link rel="stylesheet" type="text/css" href="../web/estiloInd.css" media="all">
	<script type="text/javascript" src="../web/view.js"></script>
</head>
<body id="main_body" >
	<img id="top" src="../web/images/top.png" alt="">
	<img src="../web/images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../web/index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Autoridad de Certificación Revocada con Éxito.</h2>
			<p>A continuación puede comprobar como la lista de revocación de certificados incluye únicamente al certificado raíz de la autoridad de certificación con número de serie '0' (cero), recuerde que es muy recomendable que la ponga a disposición de los clientes de la misma lo antes posible, para ello puede descargarla desde la sección: "Lista de Revocación de Certificados".</p>
		</div>
		<ul>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div align="left"><a href="../web/CAs/""" + idCA + """/crl.html"><img src="../web/images/icons/report.png" width="16" height="16" /> Volver a Lista de Revocación de Certificados </a></div></td>
				<td><div align="right"><a href="../web/index.html">Ir al Inicio <img src="../web/images/icons/house.png" width="16" height="16" /></a></div></td>	
			</tr>
			</tbody>
			</table>
		<div class="section_break"></div>
		<li>
			<pre>""" + crlTexto + """</pre>
		</li>
		<div class="section_break"></div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../web/images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
	print html.encode("utf-8")


if __name__ == '__main__':
	print "Content-Type: text/html"     # sigue HTML
	print								# linea en blanco, fin de la cabecera
	sys.stderr = sys.stdout
	try:
		# capturando el idCA
		form = cgi.FieldStorage()
		idCA = form["idCA"].value

		# cambiando el valor de la etiqueta '<estado>' de 'CAs.xml' a 'revocado'
		dirAct = os.getcwd()
		pathCasXML = dirAct + "/web/CAs/CAs.xml"
		pathCertsXML = dirAct + "/web/CAs/" + idCA + "/certs.xml"
		xmlObjCA = _xml.XMLCA(pathCasXML)
		xmlObjCA.cambiaEstado(idCA, 'revocado')		# revoca la CA en CAs.xml
		xmlObjCerts = _xml.XMLCA(pathCertsXML)
		xmlObjCerts.revocaCerts(idCA)		# revoca todos los certs emitidos y validos en certs.xml


		# cambia el archivo con la imagen del candado actual al del candado revocado
		lib.miarc_util.copiarArchivo(dirAct + '/web/images/icons/candadoRev.png', dirAct + '/web/CAs/' + idCA + '/candado.png')

		#  creando el cert. revocado
		certiRevoc = crl.CertificadoRevocado()
		certiRevoc.setSerial(0)				# '0' es el número de serie del certificado raíz de la CA
		certiRevoc.setRevocationDate()

		# creación de la CRL
		listaRevocacion = crl.CRL()
		listaRevocacion.setLastUpdate()
		listaRevocacion.setNextUpdate()		# no se va a volver a actualizar
		listaRevocacion.setIssuer(idCA)

		obj = RevocarCA(idCA)
		# añadiendo el certificado revocado, firmando y guardando la CRL
		listaRevocacion.addRevocado(certiRevoc.certRev)
		listaRevocacion.sign(idCA, obj.web_passphrase_callback, 'sha1')
		listaRevocacion.writePem(idCA)

		revocar.actualizaRevocadosXML(idCA, certiRevoc)		# actualiza el archivo revocados.xml		
		generaRespHtml(idCA, listaRevocacion)

	except:
		print "\n\n<PRE>"
		traceback.print_exc()

