#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-

import CGIHTTPServer
import os
import cgi
import urllib
import time
import random

class HTTPRequestHandler (CGIHTTPServer.CGIHTTPRequestHandler):
	"""
	Manejador que responde a peticiones HTTP.
	"""

	def do_GET(self):
		"""
		Gestiona los GET.
		"""		
		if self.path[-12:] == "formReq.html":						# EventoReq: se accede a /web/formReq.html
			self.gestionEventoReq()
		if (self.path[-3:]  == ".js" or self.path[-4:]  == ".css"):	# Evento: se accede a un archivo '.js' o '.css'
			self.envia_fichero("",self.path[1:])
		else:
			self.envia_fichero(os.getcwd(), self.path)				# Evento: se accede a otro tipo de archivo no contemplado

	def gestionEventoReq(self):
		""" 
		Respuesta del servidor a una petición a /formReq.html
		"""
		self.generaFormReq()

	def generaFormReq (self):
		""" 
		Genera el formulario html formReq.html conteniendo entre otros una 
		imagen con un código de seguridad que el usuario deberá teclear 
		para aceptar la petición.
		"""
		htmlCode = unicode(\
"""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Nuevo Solicitud de Certificado Digital.</title>
	<link rel="stylesheet" type="text/css" href="./view.css" media="all">
	<script type="text/javascript" src="./view.js"></script>
	<script type="text/javascript" src="./calendar.js"></script>
	<script languaje="javascript">
	function confirmarBorrado(form)
	{
		borrar = window.confirm('Se borrarán todos los datos del formulario.');
		(borrar)?form.reset():'return false';
	}
	</script>
	<script languaje="javascript">
	function validar(form)
	{
		mensError = ''
		formCorrecto = true
		// Chequeo del NIF/CIF
		if(form.identificacion.value == ''){
			mensError += "ERROR: no puede dejar el campo: Número o Código de Identificación Fiscal  en blanco.\\n"
			formCorrecto = false
		}
		if(form.identificacion.value != ''){
			cif = form.identificacion.value
			par = 0
			non = 0
			letras = "ABCDEFGHKLMNPQS"
			let = cif.charAt(0)
			if (!isNaN(let))
			{
				dni = cif.substring(0, cif.length-1)
				let = cif.charAt(cif.length-1)
				if (!isNaN(let))
				{
					mensError += "ERROR: Falta la letra del NIF.\\n"
					formCorrecto = false
				}
				else
				{
					cadena= "TRWAGMYFPDXBNJZSQVHLCKET"
					posicion = dni % 23
					letra = cadena.substring(posicion,posicion+1)
					if (letra != let.toUpperCase())
					{
						mensError += "ERROR: El NIF no es válido.\\n"
						formCorrecto = false
					}
				}
			}
			else
			{
				if (cif.length != 9)
				{
					mensError += "ERROR: El CIF debe tener 9 dígitos.\\n"
					formCorrecto = false
				}
				if ((letras.indexOf(let.toUpperCase())==-1) && formCorrecto)
				{
					mensError += "ERROR: El comienzo del CIF no es válido.\\n"
					formCorrecto = false
				}
				for (zz=2; zz<8; zz+=2)
				{
					par = par + parseInt(cif.charAt(zz))
				}
				for (zz=1; zz<9; zz+=2)
				{
					nn = 2*parseInt(cif.charAt(zz))
					if (nn > 9) nn = 1+(nn-10)
						non = non+nn
				}
				parcial = par + non
				control = (10 - ( parcial % 10))

				if ((control != cif.charAt(8)) && formCorrecto)
				{
				  mensError += "ERROR: El CIF no es válido.\\n"
				  formCorrecto = false
				}
			}
		}
		// Comprobamos si se ha introducido el Nombre Común (CN)
		if(form.comName.value == ''){
			mensError += "ERROR: no puede dejar el campo: Nombre Común en blanco.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido el Apellido (SN)
		if(form.surname.value == ''){
			mensError += "ERROR: no puede dejar el campo: Apellido en blanco.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido la Organización (O)
		if(form.org.value == ''){
			mensError += "ERROR: no puede dejar el campo: Organización en blanco.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido la Unidad de la Organización (OU)
		if(form.uniOrg.value == ''){
			mensError += "ERROR: no puede dejar el campo: Unidad de la Organización en blanco.\\n"
			formCorrecto = false
		}
		// Comprobando que se ha introducido el email
		if(form.emaCont.value == ''){
			mensError += "ERROR: es obligatorio introducir el Email del cliente.\\n"
			formCorrecto = false
		}
		// Control del formato del email
		if (form.emaCont.value != ''){
			if (!(/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(form.emaCont.value))){
				mensError += "ERROR: el formato del email no es correcto.\\n"
				formCorrecto = false
			}
		}
		// Comprobamos si se han introducido los Datos de Localización
		if((form.ciudad.value == '') || (form.provincia.value == '') || (form.pais.value == '')){
			mensError += "ERROR: debe rellenar completamente los Datos de Localización.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido el password
		if(form.password.value == ''){
			mensError += "ERROR: debe establecer un password.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido la verificación del password
		if(form.vPassword.value == ''){
			mensError += "ERROR: debe verificar el password.\\n"
			formCorrecto = false
		}
		// Comprobamos que coincidan
		if(form.password.value != form.vPassword.value){
			mensError += "ERROR: No coinciden las claves.\\n"
			formCorrecto = false
		}
		// Comprobamos si se ha introducido el uso del certificado
		if(form.uso.value == ''){
			mensError += "ERROR: debe establecer un uso.\\n"
			formCorrecto = false
		}
		// Comprobación de que se han rellenado los tres campos de la fecha de caducidad
		if (form.fechaCaduc_1.value == '' || form.fechaCaduc_2.value == '' || form.fechaCaduc_3.value == ''){
			mensError += "ERROR: debe elegir una fecha de caducidad.\\n"
			formCorrecto = false
		}
		// Comprobando que la fecha introducida es posterior a la actual
		if (form.fechaCaduc_1.value != '' && form.fechaCaduc_2.value != '' && form.fechaCaduc_3.value != ''){
			fechaActual = new Date()
			cadFechaIntro = form.fechaCaduc_2.value + '/' + form.fechaCaduc_1.value + '/' + form.fechaCaduc_3.value
			fechaInt = new Date(cadFechaIntro)
			if (fechaInt < fechaActual){
				mensError += "ERROR: la fecha de caducidad debe ser posterior a la actual.\\n"
				formCorrecto = false
			}
		}
		// Comprobamos si se ha introducido el código de seguridad
		if(form.codigo.value == ''){
			mensError += "ERROR: debe introducir el código de seguridad.\\n"
			formCorrecto = false
		}
		if (!formCorrecto)
			alert(mensError)
		return formCorrecto
	}
	</script>
</head>
<body id="main_body" >
	<img id="top" src="./images/top.png" alt="">
	<img src="./images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<div id="form_container">
		<br>
		<form id="form_43076" class="appnitro"  method="post" action="http://localhost:8000/cgi-bin/prevReq.py" onSubmit = "return validar(this)">
		<div class="form_description">
			<h2>Solicitud de Certificado Digital.</h2>
			<p>El siguiente formulario le permite solicitar un <B>certificado digital</B> vía web.<br/>
			Debe rellenar al menos todos los campos marcados con un asterizco (*).</p>
		<ul>
		<li class="section_break">
			<h3>Identificación del Peticionario.</h3>
			<p>Complete los siguientes campos con los datos de la persona física o jurídica que deberá de demostrar propios mediante su documentación a efectos de cotejación a la hora de recoger el certificado.</p>
		</li>
		<li id="li_1" >
			<label class="description" for="identificacion">*Número o Código de Identificación Fiscal: </label>
			<div>
				<input id="identificacion" name="identificacion" class="element text medium" type="text" maxlength="9" value=""/> 
			</div><p class="guidelines" id="guide_2"><small>Rellene con su número de NIF en el caso en que se trate de una persona física y con su CIF cuando se trate de una jurídica.</small></p>
		</li>
		<li class="section_break">
			<h3>Información del Titular.</h3>
			<p>Rellene los siguientes campos con la información de la persona, organización o empresa que será titular del certificado, esta información formará parte del propio certificado y tendrán acceso a ella los usuarios del mismo.</p>
		</li>
		<li id="li_2" >
			<label class="description" for="comName">*Nombre Común (CN): </label>
			<div>
				<input id="comName" name="comName" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_2"><small>Este campo se utiliza para identificar comúnmente a la persona, empresa u organización titular del certificado.</small></p> 
		</li>
		<li id="li_3" >
			<label class="description" for="surname">*Apellido (SN): </label>
			<div>
				<input id="surname" name="surname" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_3"><small>Úsese en el caso en que el cliente sea una persona.</small></p> 
		</li>
		<li id="li_4" >
			<label class="description" for="givName">Sobrenombre (GN): </label>
			<div>
				<input id="givName" name="givName" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_4"><small>Posible segundo nombre o sobrenombre si existiese.</small></p>
		</li>
		<li id="li_5" >
			<label class="description" for="serial">Número de Serie: </label>
			<div>
				<input id="serial" name="serial" class="element text medium" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_5"><small>Código alfanumérico que identifique de alguna manera al propietario.</small></p> 
		</li>
		<li id="li_6" >
			<label class="description" for="org">*Organización (O): </label>
			<div>
				<input id="org" name="org" class="element text large" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_6"><small>Por ejemplo: el nombre de una compañía.</small></p>
		</li>
		<li id="li_7" >
			<label class="description" for="uniOrg">*Unidad Organizativa (OU): </label>
			<div>
				<input id="uniOrg" name="uniOrg" class="element text large" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_7"><small>Le permite diferenciar varias partes de una misma organización.</small></p>
		</li>
		<li id="li_8" >
			<label class="description" for="emaCont">*Email: </label>
			<div>
				<input id="emaCont" name="emaCont" class="element text large" type="text" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_8"><small>Dirección de correo electrónico de contacto.</small></p> 
		</li>
		<li id="li_9" >
			<label class="description" for="loc">*Datos de Localización: </label>
			<div class="left">
				<input id="ciudad" name="ciudad" class="element text medium" value="" type="text">
				<label for="ciudad">Ciudad</label>
			</div>	
			<div class="right">
				<input id="provincia" name="provincia" class="element text medium" value="" type="text">
				<label for="provincia">Estado / Provincia / Región</label>
			</div>
			<div class="left">
				<select class="element select medium" id="pais" name="pais"> 
					<option value="" selected="selected"></option>
					<option value="ES"> Spain</option>
					<option value="US"> United States of America</option>
					<option value="CA"> Canada</option>
					<option value="AX"> Aland Islands</option>
					<option value="AD"> Andorra</option>
					<option value="AE"> United Arab Emirates</option>
					<option value="AF"> Afghanistan</option>
					<option value="AG"> Antigua and Barbuda</option>
					<option value="AI"> Anguilla</option>
					<option value="AL"> Albania</option>
					<option value="AM"> Armenia</option>
					<option value="AN"> Netherlands Antilles</option>
					<option value="AO"> Angola</option>
					<option value="AQ"> Antarctica</option>
					<option value="AR"> Argentina</option>
					<option value="AS"> American Samoa</option>
					<option value="AT"> Austria</option>
					<option value="AU"> Australia</option>
					<option value="AW"> Aruba</option>
					<option value="AZ"> Azerbaijan</option>
					<option value="BA"> Bosnia and Herzegovina</option>
					<option value="BB"> Barbados</option>
					<option value="BD"> Bangladesh</option>
					<option value="BE"> Belgium</option>
					<option value="BF"> Burkina Faso</option>
					<option value="BG"> Bulgaria</option>
					<option value="BH"> Bahrain</option>
					<option value="BI"> Burundi</option>
					<option value="BJ"> Benin</option>
					<option value="BM"> Bermuda</option>
					<option value="BN"> Brunei Darussalam</option>
					<option value="BO"> Bolivia</option>
					<option value="BR"> Brazil</option>
					<option value="BS"> Bahamas</option>
					<option value="BT"> Bhutan</option>
					<option value="BV"> Bouvet Island</option>
					<option value="BW"> Botswana</option>
					<option value="BY"> Belarus</option>
					<option value="BZ"> Belize</option>
					<option value="CA"> Canada</option>
					<option value="CC"> Cocos (Keeling) Islands</option>
					<option value="CF"> Central African Republic</option>
					<option value="CG"> Congo</option>
					<option value="CD"> Congo, Democratic Republic of the</option>
					<option value="CH"> Switzerland</option>
					<option value="CI"> Cote D'Ivoire (Ivory Coast)</option>
					<option value="CK"> Cook Islands</option>
					<option value="CL"> Chile</option>
					<option value="CM"> Cameroon</option>
					<option value="CN"> China</option>
					<option value="CO"> Colombia</option>
					<option value="CR"> Costa Rica</option>
					<option value="CS"> Czechoslovakia (former)</option>
					<option value="CU"> Cuba</option>
					<option value="CV"> Cape Verde</option>
					<option value="CX"> Christmas Island</option>
					<option value="CY"> Cyprus</option>
					<option value="CZ"> Czech Republic</option>
					<option value="DE"> Germany</option>
					<option value="DJ"> Djibouti</option>
					<option value="DK"> Denmark</option>
					<option value="DM"> Dominica</option>
					<option value="DO"> Dominican Republic</option>
					<option value="DZ"> Algeria</option>
					<option value="EC"> Ecuador</option>
					<option value="EE"> Estonia</option>
					<option value="EG"> Egypt</option>
					<option value="EH"> Western Sahara</option>
					<option value="ER"> Eritrea</option>
					<option value="ET"> Ethiopia</option>
					<option value="FI"> Finland</option>
					<option value="FJ"> Fiji</option>
					<option value="FK"> Falkland Islands (Malvinas)</option>
					<option value="FM"> Micronesia</option>
					<option value="FO"> Faroe Islands</option>
					<option value="FR"> France</option>
					<option value="FX"> France, Metropolitan</option>
					<option value="GA"> Gabon</option>
					<option value="GB"> Great Britain (UK)</option>
					<option value="GD"> Grenada</option>
					<option value="GE"> Georgia</option>
					<option value="GF"> French Guiana</option>
					<option value="GG"> Guernsey GH Ghana</option>
					<option value="GI"> Gibraltar</option>
					<option value="GL"> Greenland</option>
					<option value="GM"> Gambia</option>
					<option value="GN"> Guinea</option>
					<option value="GP"> Guadeloupe</option>
					<option value="GQ"> Equatorial Guinea</option>
					<option value="GR"> Greece</option>
					<option value="GS"> S. Georgia and S. Sandwich Isls.</option>
					<option value="GT"> Guatemala</option>
					<option value="GU"> Guam</option>
					<option value="GW"> Guinea-Bissau</option>
					<option value="GY"> Guyana</option>
					<option value="HK"> Hong Kong</option>
					<option value="HM"> Heard and McDonald Islands</option>
					<option value="HN"> Honduras</option>
					<option value="HR"> Croatia (Hrvatska)</option>
					<option value="HT"> Haiti</option>
					<option value="HU"> Hungary</option>
					<option value="ID"> Indonesia</option>
					<option value="IE"> Ireland</option>
					<option value="IL"> Israel</option>
					<option value="IM"> Isle of Man</option>
					<option value="IN"> India</option>
					<option value="IO"> British Indian Ocean Territory</option>
					<option value="IQ"> Iraq</option>
					<option value="IR"> Iran</option>
					<option value="IS"> Iceland</option>
					<option value="IT"> Italy</option>
					<option value="JE"> Jersey</option>
					<option value="JM"> Jamaica</option>
					<option value="JO"> Jordan</option>
					<option value="JP"> Japan</option>
					<option value="KE"> Kenya</option>
					<option value="KG"> Kyrgyzstan</option>
					<option value="KH"> Cambodia</option>
					<option value="KI"> Kiribati</option>
					<option value="KM"> Comoros</option>
					<option value="KN"> Saint Kitts and Nevis</option>
					<option value="KP"> Korea (North)</option>
					<option value="KR"> Korea (South)</option>
					<option value="KW"> Kuwait</option>
					<option value="KY"> Cayman Islands</option>
					<option value="KZ"> Kazakhstan</option>
					<option value="LA"> Laos</option>
					<option value="LB"> Lebanon</option>
					<option value="LC"> Saint Lucia</option>
					<option value="LI"> Liechtenstein</option>
					<option value="LK"> Sri Lanka</option>
					<option value="LR"> Liberia</option>
					<option value="LS"> Lesotho</option>
					<option value="LT"> Lithuania</option>
					<option value="LU"> Luxembourg</option>
					<option value="LV"> Latvia</option>
					<option value="LY"> Libya</option>
					<option value="MA"> Morocco</option>
					<option value="MC"> Monaco</option>
					<option value="MD"> Moldova</option>
					<option value="ME"> Montenegro</option>
					<option value="MG"> Madagascar</option>
					<option value="MH"> Marshall Islands</option>
					<option value="MK"> Macedonia</option>
					<option value="ML"> Mali</option>
					<option value="MM"> Myanmar</option>
					<option value="MN"> Mongolia</option>
					<option value="MO"> Macau</option>
					<option value="MP"> Northern Mariana Islands</option>
					<option value="MQ"> Martinique</option>
					<option value="MR"> Mauritania</option>
					<option value="MS"> Montserrat</option>
					<option value="MT"> Malta</option>
					<option value="MU"> Mauritius</option>
					<option value="MV"> Maldives</option>
					<option value="MW"> Malawi</option>
					<option value="MX"> Mexico</option>
					<option value="MY"> Malaysia</option>
					<option value="MZ"> Mozambique</option>
					<option value="NA"> Namibia</option>
					<option value="NC"> New Caledonia</option>
					<option value="NE"> Niger</option>
					<option value="NF"> Norfolk Island</option>
					<option value="NG"> Nigeria</option>
					<option value="NI"> Nicaragua</option>
					<option value="NL"> Netherlands</option>
					<option value="NO"> Norway</option>
					<option value="NP"> Nepal</option>
					<option value="NR"> Nauru</option>
					<option value="NT"> Neutral Zone</option>
					<option value="NU"> Niue</option>
					<option value="NZ"> New Zealand (Aotearoa)</option>
					<option value="OM"> Oman</option>
					<option value="PA"> Panama</option>
					<option value="PE"> Peru</option>
					<option value="PF"> French Polynesia</option>
					<option value="PG"> Papua New Guinea</option>
					<option value="PH"> Philippines</option>
					<option value="PK"> Pakistan</option>
					<option value="PL"> Poland</option>
					<option value="PM"> St. Pierre and Miquelon</option>
					<option value="PN"> Pitcairn</option>
					<option value="PR"> Puerto Rico</option>
					<option value="PS"> Palestinian Territory</option>
					<option value="PT"> Portugal</option>
					<option value="PW"> Palau</option>
					<option value="PY"> Paraguay</option>
					<option value="QA"> Qatar</option>
					<option value="RE"> Reunion</option>
					<option value="RO"> Romania</option>
					<option value="RS"> Serbia RU Russian Federation</option>
					<option value="RW"> Rwanda</option>
					<option value="SA"> Saudi Arabia</option>
					<option value="SB"> Solomon Islands</option>
					<option value="SC"> Seychelles</option>
					<option value="SD"> Sudan</option>
					<option value="SE"> Sweden</option>
					<option value="SG"> Singapore</option>
					<option value="SH"> St. Helena</option>
					<option value="SI"> Slovenia</option>
					<option value="SJ"> Svalbard and Jan Mayen Islands</option>
					<option value="SK"> Slovak Republic</option>
					<option value="SL"> Sierra Leone</option>
					<option value="SM"> San Marino</option>
					<option value="SN"> Senegal</option>
					<option value="SO"> Somalia</option>
					<option value="SR"> Suriname</option>
					<option value="ST"> Sao Tome and Principe</option>
					<option value="SU"> USSR (former)</option>
					<option value="SV"> El Salvador</option>
					<option value="SY"> Syria</option>
					<option value="SZ"> Swaziland</option>
					<option value="TC"> Turks and Caicos Islands</option>
					<option value="TD"> Chad</option>
					<option value="TF"> French Southern Territories</option>
					<option value="TG"> Togo</option>
					<option value="TH"> Thailand</option>
					<option value="TJ"> Tajikistan</option>
					<option value="TK"> Tokelau</option>
					<option value="TM"> Turkmenistan</option>
					<option value="TN"> Tunisia</option>
					<option value="TO"> Tonga</option>
					<option value="TP"> East Timor</option>
					<option value="TR"> Turkey</option>
					<option value="TT"> Trinidad and Tobago</option>
					<option value="TV"> Tuvalu</option>
					<option value="TW"> Taiwan</option>
					<option value="TZ"> Tanzania</option>
					<option value="UA"> Ukraine</option>
					<option value="UG"> Uganda</option>
					<option value="UM"> US Minor Outlying Islands</option>
					<option value="US"> United States</option>
					<option value="UY"> Uruguay</option>
					<option value="UZ"> Uzbekistan</option>
					<option value="VA"> Vatican City State (Holy See)</option>
					<option value="VC"> Saint Vincent and the Grenadines</option>
					<option value="VE"> Venezuela</option>
					<option value="VG"> Virgin Islands (British)</option>
					<option value="VI"> Virgin Islands (U.S.)</option>
					<option value="VN"> Viet Nam</option>
					<option value="VU"> Vanuatu</option>
					<option value="WF"> Wallis and Futuna Islands</option>
					<option value="WS"> Samoa</option>
					<option value="YE"> Yemen</option>
					<option value="YT"> Mayotte</option>
					<option value="ZA"> South Africa</option>
					<option value="ZM"> Zambia</option>
					<option value="ZW"> Zimbabwe</option>
				</select>
			<label for="pais">País</label>
			</div><p class="guidelines" id="guide_8"><small>Rellene con los datos de localización habitual del que será el propietario del certificado.</small></p> 
		</li>
		<li class="section_break">
			<h3>Uso del Certificado.</h3>
			<p>	Seleccione aquel de los usos definidos en la siguiente lista para el cual será utilizado el certificado digital.</p>
		</li>
		<li id="li_16" >
			<label class="description" for="uso">*Uso del certificado: </label>
			<div class="left">
				<select class="element select medium" id="uso" name="uso">
					<option value=1> SSL Client</option>
					<option value=2> SSL Client CA</option>
					<option value=3> SSL Server</option>
					<option value=4> SSL Server CA</option>
					<option value=5> Netscape SSL Server</option>
					<option value=6> S/MIME Signing</option>
					<option value=7> S/MIME Encryption</option>
					<option value=8> S/MIME CA</option>
					<option value=9> CRL Signing</option>
					<option value=10> CRL Signing CA</option>
				</select>
				<p class="guidelines" id="guide_16"><small>Seleccione el uso que se le dará al certificado digital.</small></p>
			</div> 
		</li>
		<li class="section_break">
			<h3>Claves Pública y Privada.</h3>
			<p>A continuación se requiere que proporcione los datos necesarios para generar el par de claves RSA asociadas al Certificado Digital.</p>
		</li>
		<li id="li_17" >
			<label class="description" for="numBits">Número de bits de la Clave Privada: </label>
			<div>
			<select class="element select medium" id="numBits" name="numBits"> 
				<option value="0" >512</option>
				<option value="1" selected="selected">1024</option>
				<option value="2" >2048</option>
				<option value="3" >3072</option>
				<option value="4" >4096</option>
		</select>
		</div><p class="guidelines" id="guide_17"><small>En caso de duda se recomienda mantener el valor por defecto.</small></p> 
		</li>
		<li id="li_18" >
			<label class="description" for="exp">Exponente: </label>
			<div>
			<select class="element select medium" id="exp" name="exp"> 
				<option value="1" >RSA_3 (0x03L)</option>
				<option value="2" selected="selected">RSA_F4 (0x10001L)</option>
			</select>
			</div><p class="guidelines" id="guide_18"><small>En caso de duda se recomienda mantener el valor por defecto.</small></p> 
		</li>
		<li id="li_12" >
			<label class="description" for="password">*Password: </label>
			<div>
				<input id="password" name="password" class="element text large" type="password" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_12"><small>Este password será utilizado en el proceso de creación de las claves del certificado.</small></p>
		</li>
		<li id="li_13" >
			<label class="description" for="vPassword">*Verificación del Password: </label>
			<div>
				<input id="vPassword" name="vPassword" class="element text large" type="password" maxlength="255" value=""/> 
			</div><p class="guidelines" id="guide_13"><small>Vuelva a escribir el password anterior.</small></p> 
		</li>
		<li id="li_19">
			<label class="description" for="firma">*Algoritmo de Firma: </label>
			<div>
			<select class="element select medium" id="firma" name="firma"> 
				<option value="md5" >MD5</option>
				<option value="sha1" selected="selected">SHA1 (DSS1)</option>
				<option value="sha224" >SHA224</option>
				<option value="sha256" >SHA256</option>
				<option value="ripemd160" >RIPEMD-160</option>
			</select>
			</div><p class="guidelines" id="guide_19"><small>Se recomienda usar SHA1 y RIPEMD-160, seleccione MD5 solo en caso de necesidad de compatibilidad software.</small></p> 
		</li>
		<li class="section_break">
			<h3>Validez del Certificado</h3>
			<p>El certificado será válido a partir del momento de emisión hasta la fecha que elija a continuación.</p>
		</li>		
		<li id="li_15" >
			<label class="description" for="fechaCaduc">*Fecha de Caducidad: </label>
			<span>
				<input id="fechaCaduc_1" name="fechaCaduc_1" class="element text" size="2" maxlength="2" value="" type="text"> /
				<label for="fechaCaduc_1">DD</label>
			</span>
			<span>
				<input id="fechaCaduc_2" name="fechaCaduc_2" class="element text" size="2" maxlength="2" value="" type="text"> /
				<label for="fechaCaduc_2">MM</label>
			</span>
			<span>
		 		<input id="fechaCaduc_3" name="fechaCaduc_3" class="element text" size="4" maxlength="4" value="" type="text">
				<label for="fechaCaduc_3">AAAA</label>
			</span>
	
			<span id="calendar_15">
				<img id="cal_img_15" class="datepicker" src="./images/calendar.gif" alt="Seleccione una fecha.">	
			</span>
			<script type="text/javascript">
				Calendar.setup({
				inputField	 : "fechaCaduc_3",
				baseField    : "fechaCaduc",
				displayArea  : "calendar_15",
				button		 : "cal_img_15",
				ifFormat	 : "%B %e, %Y",
				onSelect	 : selectEuropeDate
				});
			</script>
			<p class="guidelines" id="guide_15"><small>Último día de validez del certificado.</small></p> 
		</li>
		<li class="section_break">
			<h3>Validación del formulario.</h3>
			<p>Una vez rellenado el formulario, antes de enviarlo debe escribir en el campo de la derecha el código que se encuentran en la imagen.</p>
		</li>\n\t\t"""
		+ self.generaCodSeg() +
		"""\n<li class="buttons">
		    <input type="hidden" name="form_id" value="43076" />
		    <input type="button" value="Borrar" onClick="confirmarBorrado(this.form)" />
			<input id="saveForm" class="button_text" type="submit" name="submit" value="Enviar" />
		</li>
		</ul>
		</div>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="./images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		dirAct = os.getcwd()
		f = open(dirAct + '/web/formReq.html', 'w') 		# creamos el archivo
		f.write(htmlCode.encode("utf-8"))
		f.close()

	def generaCodSeg(self):
		""" Crea el código html de la entrada con el código de seguridad.
		"""
		alInt = random.randint(0, 29)						# número aleatorio entre 0 y 19
		htmlCode = """<li id="li_20" >
			<label class="description" for="codigo">*Código de Seguridad: </label>
			<input id="numCod" name="numCod" class="element text medium" type="hidden" value='""" + str(alInt) + """'/>
			<div>
				<span id="codseg_20">
					<img id="codpng" src="./images/codigos/""" + str(alInt) + """/codseg.png" title="Código de seguridad.">
				</span>
					<input id="codigo" name="codigo" class="element text small" type="text" maxlength="4" value=""/>
			</div><p class="guidelines" id="guide_20"><small>Para evitar envios automáticos introduce el código de la imagen.</small></p> 
		</li>"""
		return htmlCode

	def envia_fichero(self, ruta, fichero):
		p = Pagina(ruta + fichero)
		self.enviar_respuesta(p.tipo(), p.contenido())

	def enviar_respuesta(self, tipo, contenido):
		self.enviar_cabecera(tipo)
		self.wfile.write(contenido)		# contenido es lo que se devuelve al cliente
    
	def enviar_cabecera(self, tipo):
		self.send_response(200)
		self.send_header("Content-type","text/" + tipo)
		self.end_headers()


class Pagina:
    def __init__(self,nombre):
        self.nombre = nombre
        self.texto = ""
        fichero = file(self.nombre)
        self.texto = fichero.read()
        fichero.close()

    def contenido(self):
        return self.texto

    def tipo(self):
        tipo = "html"
        ext = self.nombre[-4:]
        if (ext == "html"):
            tipo = "html"
        elif (ext == ".xml"):
            tipo = "xml"
        elif (ext == ".css"):
            tipo = "css"
        return tipo


def comparaConFechaAct (fecha):
	"""
	Compara la fecha pasada como argumento con la del sistema y devuelve un 
	lógico indicando si la pasada como argumento es anterior.

	El formato de la fecha argumento debe ser: "DD-MM-AAAA"
	"""
	dia = int(fecha[0:2])
	mes = int(fecha[3:5])
	anyo = int(fecha[6:10])
	res = True
	tupTime = time.localtime()
	if anyo < tupTime.tm_year:
		res = True
	elif anyo > tupTime.tm_year:
		res = False
	else:
		if mes < tupTime.tm_mon:
			res = True
		elif mes > tupTime.tm_mon:
			res = False
		else:
			if dia < tupTime.tm_mday:
				res = True
			else:
				res = False
	return res
